#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93 (BSDI)";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYEMPTY (-1)
#define YYLEX yylex()
#define yyclearin (yychar=YYEMPTY)
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "parser.y"
/*
 *  parser.y,v 1.60.2.12 1994/01/26 20:01:30 jch Exp
 */

/* Gated Release 3.0 */
/* Copyright (c) 1990,1991,1992,1993 by Cornell University. All rights reserved. */
/* Refer to Particulars and other Copyright notices at the end of this file. */


#include "include.h"
#ifdef	PROTO_INET
#include "inet.h"
#endif	/* PROTO_INET */
#ifdef	PROTO_ISO
#include "iso.h"
#endif	/* PROTO_ISO */
#include "parse.h"
#include "krt.h"
#ifdef	PROTO_RIP
#include "rip.h"
#endif	/* PROTO_RIP */
#ifdef	PROTO_HELLO
#include "hello.h"
#endif	/* PROTO_HELLO */
#include "ospf.h"
#ifdef	PROTO_EGP
#include "egp.h"
#endif	/* PROTO_EGP */
#ifdef	PROTO_BGP
#include "bgp.h"
#endif	/* PROTO_BGP */
#ifdef	PROTO_DVMRP
#include "dvmrp.h"
#endif	/* PROTO_DVMRP */
#ifdef	PROTO_ISODE_SNMP
#include "snmp_isode.h"
#endif	/* PROTO_ISODE_SNMP */
#ifdef	 PROTO_ISIS
#include "isis.h"
#include "isis_test.h"
#include "isis_globals.h"
#endif	/* PROTO_ISIS */
  
#undef	vsprintf

char parse_error[LINE_MAX] = { 0 };
char *parse_filename = 0;

static	proto_t	parse_proto;			/* For correctly tagging ADV lists */
static	proto_t	parse_export_proto;		/* For checking metrics */
static	gw_entry	**parse_gwlist;
static	gw_entry	*parse_gwp;		/* To fake a list for EGP and BGP */
static  char *parse_serv_proto;
static	int	parse_contig_masks = TRUE;	/* Masks must be contiguous */
static	int parse_group_index;
static	egp_neighbor *ngp, egp_group, *gr_ngp;
static	bgpPeer *bnp;
static	bgpPeerGroup *bgp;
static 	struct bgp_conf *bcp;
static struct AREA *ospf_AREA;
static if_info parse_ifi;	/* Used for configuring interfaces that do not exist */

u_int parse_state = PS_INITIAL;
proto_t protos_seen = 0;

PROTOTYPE(yyerror,
	  static void,
	  (const char *));

#define	free_string(s)	task_mem_free((task *) 0, (caddr_t) s); s = 0
#define	free_charstr(s)	task_mem_free((task *) 0, (caddr_t) (s)->ptr); (s)->ptr = (char *) 0; (s)->len = (s)->type = 0
#define	free_bytestr(s)	task_mem_free((task *) 0, (caddr_t) (s)->ptr); (s)->ptr = (byte *) 0; (s)->len = (s)->type = 0

#define	PARSE_ERROR	yyerror(parse_error); yynerrs++; YYERROR;

#define	PROTO_SEEN(proto) \
	if (BIT_TEST(protos_seen, RTPROTO_BIT(proto))) { \
	    sprintf(parse_error, "parse_proto_seen: duplicate %s clause", gd_lower(trace_state(rt_proto_bits, proto))); \
	    PARSE_ERROR; \
	} else { \
	    BIT_SET(protos_seen, RTPROTO_BIT(proto)); \
	    parse_proto = proto; \
	} \

#ifdef	PROTO_ASPATHS
static unsigned	aspath_state;
static asmatch_t *aspath_current;

#define	ASPATH_NEXT_STATE	if (aspath_state++ == ASP_BITS) { \
	sprintf(parse_error, "too many AS path regexp states"); \
	PARSE_ERROR; \
    }
#endif	/* PROTO_ASPATHS */

#line 99 "parser.y"
typedef union {
    long	num;
    u_long	u_num;
    bytestr	hex;
    charstr	str;
    flag_t	flag;
    time_t	time;
    as_t	as;
    proto_t	proto;
    pmet_t	metric;
    pref_t	pref;
    if_addr	*ifap;
    if_addr_entry	*ifae;
    adv_entry	*adv;
    gw_entry	*gwp;
    void_t	vt;
    sockaddr_un	*sockaddr;
#ifdef	PROTO_INET
    struct in_addr in_addr;
#endif	/* PROTO_INET */
    dest_mask	dm;
    struct {
	pmet_t metric;
	adv_entry *adv;
    } metric_adv ;
    struct {
	proto_t proto;
	adv_entry **import_list;
	adv_entry **export_list;
	gw_entry **gw_list;
    } proto_lists;
    config_entry *config;
    config_list *conflist;
#ifndef	GATED_LEXER
#ifdef	PROTO_OSPF
    ospf_config_router *ospf_router;
#endif	/* PROTO_OSPF */
#if	defined(PROTO_ASPATHS)
    asmatch_t	*asp_match;
    struct {
	u_short	begin;
	u_short end;
    } asp_range;
    struct {
	flag_t	start[1 + ASP_ACC/ASP_WORD];
	flag_t	state[1 + ASP_ACC/ASP_WORD];
    } asp_stack;
#endif	/* PROTO_ASPATHS */
#endif	/* GATED_LEXER */
} YYSTYPE;
#line 160 "y.tab.c"
#define L_EOS 257
#define L_ERROR 258
#define L_NUMBER 259
#define L_STRING 260
#define L_HNAME 261
#define L_KEYWORD 262
#define L_HEXSTRING 263
#define L_OCTETSTRING 264
#define T_DIRECT 265
#define T_INTERFACE 266
#define T_INTERFACES 267
#define T_LCLADDR 268
#define T_PROTO 269
#define T_METRIC 270
#define T_METRICIN 271
#define T_METRICOUT 272
#define T_INFINITY 273
#define T_DOWN 274
#define T_PARSE 275
#define T_ADV 276
#define T_DEFAULT 277
#define T_DEFAULTS 278
#define T_YYDEBUG 279
#define T_YYSTATE 280
#define T_YYQUIT 281
#define T_DEBUG 282
#define T_SYSLOG 283
#define T_UPTO 284
#define T_EMERG 285
#define T_ALERT 286
#define T_CRIT 287
#define T_ERR 288
#define T_WARNING 289
#define T_NOTICE 290
#define T_INFO 291
#define T_ON 292
#define T_OFF 293
#define T_GATEWAY 294
#define T_PREFERENCE 295
#define T_DEFAULTMETRIC 296
#define T_NONBROADCAST 297
#define T_BROADCAST 298
#define T_TYPE 299
#define T_POINTOPOINT 300
#define T_MULTICAST 301
#define T_NETMASK 302
#define T_DEFINE 303
#define T_NOP 304
#define T_NOP1 305
#define T_PEERAS 306
#define T_LOCALAS 307
#define T_NEIGHBOR 308
#define T_GROUP 309
#define T_NOGENDEFAULT 310
#define T_VERSION 311
#define T_DEFAULTIN 312
#define T_DEFAULTOUT 313
#define T_MAXUP 314
#define T_SOURCENET 315
#define T_PKTSIZE 316
#define T_P1 317
#define T_P2 318
#define T_BGP 319
#define T_HOLDTIME 320
#define T_TEST 321
#define T_KEEPALL 322
#define T_SENDBUF 323
#define T_RECVBUF 324
#define T_SPOOLBUF 325
#define T_EGP 326
#define T_ASPATH 327
#define T_ORIGIN 328
#define T_INCOMPLETE 329
#define T_ANY 330
#define T_TAG 331
#define T_TRUSTEDGATEWAYS 332
#define T_SOURCEGATEWAYS 333
#define T_RIP 334
#define T_NORIPOUT 335
#define T_NORIPIN 336
#define T_NOCHECKZERO 337
#define T_OSPF 338
#define T_OSPF_ASE 339
#define T_NETWORKS 340
#define T_BACKBONE 341
#define T_VIRTUALLINK 342
#define T_STUB 343
#define T_STUBHOSTS 344
#define T_RXMITINTERVAL 345
#define T_INFTRANSDELAY 346
#define T_POLLINTERVAL 347
#define T_ROUTERS 348
#define T_NEIGHBORID 349
#define T_TRANSITAREA 350
#define T_ENABLE 351
#define T_DISABLE 352
#define T_ELIGIBLE 353
#define T_MONITORAUTHKEY 354
#define T_DD 355
#define T_REQUEST 356
#define T_LSU 357
#define T_ACK 358
#define T_RECEIVE 359
#define T_LSA_BLD 360
#define T_LSA_RX 361
#define T_LSA_TX 362
#define T_TRAP 363
#define T_EXPORTINTERVAL 364
#define T_EXPORTLIMIT 365
#define T_FIRST 366
#define T_EVERY 367
#define T_AREA 368
#define T_SPF 369
#define T_HELLO 370
#define T_HELLOINTERVAL 371
#define T_ROUTERDEADINTERVAL 372
#define T_PRIORITY 373
#define T_REDIRECT 374
#define T_NOREDIRECTS 375
#define T_ICMP 376
#define T_AUTHTYPE 377
#define T_AUTHKEY 378
#define T_NONE 379
#define T_SIMPLE 380
#define T_AUTH 381
#define T_PASSIVE 382
#define T_SIMPLEX 383
#define T_STRICTIFS 384
#define T_SCANINTERVAL 385
#define T_STATIC 386
#define T_MARTIANS 387
#define T_RETAIN 388
#define T_EXPORT 389
#define T_IMPORT 390
#define T_HOST 391
#define T_MASK 392
#define T_MASKLEN 393
#define T_REJECT 394
#define T_BLACKHOLE 395
#define T_RESTRICT 396
#define T_ALLOW 397
#define T_AS 398
#define T_ROUTERID 399
#define T_IGP 400
#define T_OPTIONS 401
#define T_NOINSTALL 402
#define T_NOSEND 403
#define T_NORESOLV 404
#define T_TRACEOPTIONS 405
#define T_EXCEPT 406
#define T_TRACEFILE 407
#define T_REPLACE 408
#define T_SIZE 409
#define T_FILES 410
#define T_K 411
#define T_M 412
#define T_ALL 413
#define T_GENERAL 414
#define T_INTERNAL 415
#define T_EXTERNAL 416
#define T_ROUTE 417
#define T_UPDATE 418
#define T_KERNEL 419
#define T_TASK 420
#define T_TIMER 421
#define T_NOSTAMP 422
#define T_MARK 423
#define T_INET 424
#define T_GENDEFAULT 425
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,  137,  137,  138,  138,  138,  138,  138,  138,
  138,  138,  138,  138,  139,  139,  139,  140,  140,   80,
   80,   81,   81,   81,   84,   84,  153,  153,   77,   77,
   78,   78,   78,   79,   79,   76,   76,   73,   73,   75,
   75,   75,   75,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,  145,  154,
  146,  146,  146,  122,  122,  122,  123,  123,  114,  114,
  114,  141,  142,  155,  155,  156,  156,  156,  156,  156,
  107,  157,  107,    2,    2,    2,    1,    1,    1,    1,
    1,    1,    1,    1,  143,  158,  144,  159,  159,  159,
  160,  160,  163,  160,  161,  161,  165,  165,  162,  162,
  162,  164,  164,  166,  166,   82,   82,   83,   83,   83,
   83,   83,   83,  118,  118,  120,  120,  119,  119,  117,
  117,  115,  116,  116,  100,  105,  105,  147,  148,  148,
  148,  148,  148,  172,  171,  173,  173,  174,  174,  174,
  175,  175,  175,  175,  175,  175,  175,  175,  175,   27,
   27,   26,   26,   26,   26,   26,   26,   29,   29,   29,
   31,   31,   28,   30,  176,  170,  177,  177,  178,  178,
  178,  179,  179,  179,  179,  179,  179,  181,  179,   47,
   47,   48,   48,  180,  180,  180,  183,  183,  183,  183,
  182,  182,  182,  184,  184,  184,  184,  184,  184,   32,
   32,   33,   33,   35,   35,   35,   34,   34,   37,   37,
   37,   36,   36,   36,   36,   36,   36,   36,   36,   38,
   38,   38,   39,   39,   40,   41,   41,   42,   46,   46,
   45,   43,   43,   43,   44,   44,   44,  185,  185,  185,
  186,   52,   52,   52,   51,   50,   50,   49,   55,   56,
   53,   53,   53,   59,   59,   59,   58,   58,   54,   54,
   54,   54,   54,   54,   54,   54,   54,   54,   54,  187,
  169,  188,  188,  189,  189,  189,  190,  190,  190,  190,
  192,  190,  193,  193,  193,  195,  194,  191,  191,  191,
  197,  197,  197,  197,  197,  197,  196,  196,  198,  198,
  198,  198,  198,  198,  198,  198,  198,    3,    4,  199,
  168,  200,  200,  201,  201,  201,  202,  202,  202,  204,
  205,  202,  203,  203,  206,  206,  206,  209,  208,  210,
  208,  207,  207,  207,  207,  207,  207,  207,  207,  207,
  207,  207,  207,  207,  207,  207,  207,    6,    5,    5,
    5,    5,    7,    8,   10,   10,   10,    9,    9,    9,
  211,  167,  212,  212,  213,  213,  213,  214,  214,  214,
  214,   61,   61,   60,   62,  149,  215,  150,  216,  216,
  216,  217,  217,   63,   63,   63,   64,   64,   65,   65,
   65,   65,  151,  152,  152,  152,  152,  152,  152,  152,
   86,   87,  126,  126,  124,  124,  124,  218,  125,   88,
   57,  132,  132,  128,  128,  128,  127,  127,  127,  127,
  127,  127,  127,  127,  127,  127,   91,   92,   93,   90,
  133,  133,  131,  131,  130,  130,  130,  219,  129,  101,
  101,  109,  109,  109,  109,  112,  113,  113,  102,  102,
  121,  121,  108,  103,  103,  110,  104,  104,  111,  111,
  111,  106,  106,  135,  135,  135,   89,   89,   85,   85,
   85,   72,   72,   68,   68,   69,   69,   70,   70,   98,
   98,   99,   99,   97,  134,   66,   66,   67,   67,   71,
   71,   71,  136,  136,   94,   95,   95,   96,   96,   23,
   23,   22,   22,   22,   21,   21,   24,   25,   25,   25,
   25,   20,   20,   20,   20,  220,   11,   19,   19,   17,
   17,   18,   18,   18,   12,   12,   13,   13,   15,   15,
   15,   15,   15,   14,   14,   14,   16,   16,   16,
};
short yylen[] = {                                         2,
    0,    1,    1,    2,    1,    1,    2,    2,    2,    2,
    2,    2,    2,    1,    3,    3,    2,    3,    4,    0,
    2,    1,    2,    2,    0,    1,    0,    4,    1,    1,
    1,    2,    3,    1,    1,    1,    1,    1,    2,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    0,    0,
    6,    3,    3,    0,    4,    3,    0,    1,    1,    1,
    1,    0,    3,    1,    2,    1,    3,    1,    1,    2,
    0,    0,    3,    1,    2,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    0,    0,    6,    0,    3,    3,
    2,    3,    0,    5,    1,    2,    1,    2,    2,    2,
    0,    0,    2,    2,    1,    1,    2,    2,    3,    1,
    1,    1,    1,    0,    2,    1,    2,    1,    1,    1,
    2,    1,    1,    1,    1,    1,    1,    0,    2,    2,
    2,    2,    2,    0,    4,    0,    3,    0,    3,    3,
    2,    2,    1,    1,    2,    1,    3,    2,    2,    1,
    2,    1,    1,    2,    2,    2,    3,    0,    1,    1,
    1,    1,    1,    1,    0,    4,    0,    3,    0,    3,
    3,    4,    2,    2,    2,    2,    3,    0,    5,    0,
    2,    0,    2,    0,    3,    3,    2,    2,    2,    2,
    0,    3,    3,    2,    2,    4,    4,    2,    6,    3,
    4,    0,    3,    2,    3,    3,    0,    3,    2,    3,
    3,    1,    1,    2,    2,    2,    2,    2,    2,    1,
    2,    4,    0,    2,    1,    0,    2,    1,    2,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    3,    3,
    3,    2,    3,    3,    2,    0,    1,    1,    1,    1,
    1,    2,    3,    0,    3,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,
    4,    0,    3,    0,    3,    3,    2,    2,    2,    2,
    0,    6,    0,    3,    3,    0,    4,    0,    2,    2,
    2,    2,    2,    2,    2,    2,    0,    2,    2,    1,
    1,    1,    2,    2,    2,    2,    2,    1,    1,    0,
    4,    0,    3,    0,    3,    3,    2,    2,    2,    0,
    0,   11,    0,    2,    0,    3,    3,    0,    4,    0,
    5,    2,    2,    1,    2,    2,    2,    2,    2,    2,
    1,    1,    1,    1,    2,    2,    2,    1,    1,    1,
    1,    1,    1,    1,    0,    3,    3,    1,    1,    1,
    0,    4,    0,    3,    0,    3,    3,    2,    3,    2,
    2,    1,    2,    1,    1,    0,    0,    5,    2,    3,
    2,    6,    5,    1,    1,    1,    0,    2,    1,    1,
    1,    1,    0,    7,    6,    6,    6,    7,    6,    7,
    1,    1,    1,    4,    0,    3,    3,    0,    3,    1,
    1,    1,    4,    0,    3,    3,    5,    4,    5,    4,
    4,    4,    3,    4,    3,    3,    1,    1,    1,    1,
    1,    2,    0,    3,    0,    3,    3,    0,    3,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    1,    1,    1,    2,    1,    1,    1,    3,
    3,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    0,    2,    1,    1,    0,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    3,    5,    1,    1,    1,    1,    2,    0,    2,    0,
    2,    1,    1,    2,    0,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    0,    5,    1,    1,    1,
    3,    1,    1,    1,    1,    3,    1,    2,    1,    2,
    2,    2,    4,    1,    1,    3,    1,    2,    3,
};
short yydefred[] = {                                      0,
    0,   14,    0,    0,    0,    0,    0,    0,    0,    3,
    5,    6,    0,    0,    0,    0,    0,    0,   13,  482,
  483,    0,    0,   17,   52,   42,   43,   54,   55,   58,
   57,   56,   29,   44,   45,   46,   47,   48,   49,   53,
   50,   51,   40,   41,   34,   35,    0,    0,   31,  495,
    0,    0,    4,    0,    7,   96,    8,   60,    0,    0,
    9,  320,  280,  144,  175,  371,   10,    0,    0,    0,
    0,    0,  387,   11,    0,    0,   12,   15,   16,   18,
    0,   32,    0,    0,   26,   21,    0,   76,   78,   79,
    0,    0,   74,    0,    0,  505,    0,  472,  474,  475,
  498,  499,  450,  473,  465,    0,  451,  476,  464,    0,
    0,    0,    0,    0,  139,  140,  141,  142,  143,    0,
    0,    0,   33,  496,    0,  497,    0,   19,   94,    0,
   87,   88,   89,   90,   91,   92,   93,   84,    0,    0,
    0,   73,   75,   98,   64,   62,   63,    0,    0,    0,
    0,    0,    0,  479,  364,  319,  478,  421,  477,  480,
  481,    0,  411,    0,    0,  420,    0,    0,    0,    0,
  412,   23,   24,    0,   85,   86,  494,  491,   82,   77,
    0,    0,  324,  321,  284,  281,  148,  145,  179,  176,
  375,  372,    0,  396,    0,    0,  468,    0,  394,  395,
  467,    0,    0,    0,    0,    0,    0,    0,  126,    0,
  526,    0,    0,    0,    0,    0,   28,    0,    0,    0,
    0,    0,    0,    0,    0,  458,  457,    0,   69,   70,
   71,    0,    0,    0,    0,    0,    0,  391,  466,    0,
    0,    0,    0,  388,    0,  389,  238,  237,    0,    0,
    0,  134,  130,  132,    0,  133,  463,  461,    0,    0,
  422,    0,    0,    0,  413,    0,    0,  516,  517,    0,
    0,    0,   83,  100,  128,    0,    0,  103,  107,    0,
    0,  105,   97,   99,   66,   61,   68,    0,    0,    0,
    0,    0,    0,  323,    0,    0,    0,    0,  291,    0,
    0,  283,    0,    0,    0,    0,    0,  154,  153,    0,
    0,  156,    0,  147,    0,    0,    0,    0,  240,    0,
    0,    0,    0,    0,  178,  188,    0,    0,    0,    0,
    0,    0,  374,    0,    0,    0,  459,  471,  460,  470,
  390,    0,  511,  512,    0,    0,  131,  462,  485,  484,
  487,  424,  409,  545,    0,    0,    0,    0,    0,  544,
  415,  405,  407,    0,  406,    0,    0,  120,  121,  122,
  123,    0,  116,    0,    0,  108,  106,   65,  326,  327,
  328,    0,  329,    0,   38,  325,  286,  287,  288,  298,
  289,  290,    0,  285,  150,    0,  151,  152,    0,    0,
  155,    0,  149,  181,  194,    0,    0,  246,  186,  247,
  245,  184,  185,  239,  241,  270,  271,  272,  273,  274,
  275,  277,  276,  279,  278,    0,  261,  269,    0,  180,
  377,    0,  378,    0,  381,    0,  376,  397,    0,  514,
  410,  408,    0,    0,    0,    0,    0,  540,  541,  542,
  538,    0,  404,    0,  118,  117,    0,    0,  112,    0,
  362,  361,  359,  360,    0,   39,    0,    0,    0,    0,
  163,  162,    0,  160,    0,    0,  191,    0,  187,    0,
  262,  201,  384,  382,    0,    0,  397,    0,    0,  423,
    0,  546,  533,  534,  528,  532,    0,  530,  527,  536,
    0,    0,    0,  414,    0,    0,  119,  109,  110,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  310,    0,
  311,  312,    0,    0,    0,    0,    0,  293,  299,  300,
  164,  165,    0,  171,  166,  172,  161,    0,    0,    0,
    0,    0,  182,    0,  193,  263,    0,  383,  399,  400,
  401,  402,  398,    0,  426,  437,  440,  174,  259,  260,
  438,  439,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  425,    0,  543,    0,  417,  416,  456,    0,
  454,  455,  452,  453,  115,    0,  113,    0,  330,  314,
  136,  135,  137,  309,  313,  305,  301,  302,  304,  303,
  315,  316,  317,  306,    0,  170,  169,  167,  196,  198,
  235,  197,  200,  199,  195,    0,    0,    0,    0,    0,
    0,    0,  189,    0,    0,    0,    0,  441,    0,  435,
  436,    0,  433,    0,    0,    0,  531,  549,  493,  492,
  419,  114,  502,  333,    0,  296,  292,    0,  203,  208,
    0,  264,    0,    0,  205,    0,  242,  243,  244,  204,
  202,  428,    0,  434,  445,  442,    0,  430,  431,  432,
    0,  295,    0,  294,    0,    0,    0,    0,  234,    0,
    0,    0,  429,    0,  427,    0,    0,    0,    0,    0,
  344,    0,  352,  353,    0,  354,    0,    0,    0,  351,
    0,    0,  334,  307,    0,    0,  210,    0,  207,    0,
  267,  268,    0,    0,    0,  206,    0,  248,    0,  444,
    0,    0,  347,  342,  345,  346,  343,  350,  348,  355,
  358,  356,  357,  349,  335,    0,    0,  211,    0,    0,
  222,  223,    0,    0,    0,    0,    0,    0,  266,  265,
    0,  251,  250,  249,  447,  446,    0,    0,  308,    0,
    0,  230,    0,    0,  224,  225,  227,  228,  258,  226,
  229,    0,  213,    0,  214,  209,  489,  488,  449,    0,
  338,  340,  332,    0,  231,    0,    0,  218,    0,  219,
  216,  215,  337,    0,    0,  336,    0,    0,    0,  221,
  220,  333,  365,  252,    0,  232,    0,  257,  255,    0,
    0,  254,  253,    0,  341,    0,  369,  370,  368,  367,
  366,
};
short yydgoto[] = {                                       8,
  138,  139,  392,  160,  465,  730,  383,  161,  816,  811,
  212,  356,  357,  358,  359,  501,  497,  498,  499,  563,
  214,  343,  250,  344,  564,  474,  475,  401,  608,  565,
  535,  650,  707,  738,  747,  762,  763,  764,  655,  610,
  205,  248,  660,  409,  414,  326,  407,  479,  770,  809,
  797,  798,  426,  427,  566,  567,  162,  710,  677,  484,
  485,  435,  196,  486,  553,  350,  104,  611,  629,  779,
  376,   22,  384,  385,   46,    0,   47,   48,   49,   51,
  127,  372,  373,   86,  163,  164,  170,  165,  166,  569,
  570,  571,  572,  360,    0,    0,  178,  266,  641,  590,
  105,  338,  257,  198,  592,  107,  180,  258,  580,  199,
  200,  583,  584,  232,  253,  254,  276,  209,  277,  210,
  259,  182,  288,  452,  505,  267,  491,  443,  721,  684,
  666,  263,  630,  108,  109,    0,    9,   10,   11,   12,
   13,   55,   14,   57,   15,   61,   16,   67,   17,   74,
   18,   77,   84,   95,   92,   93,  218,   94,  181,  224,
  281,  459,  374,  510,  282,  587,   68,   69,   70,   71,
   72,  112,  188,  235,  315,  113,  190,  236,  327,  476,
  429,  547,  544,  624,  681,  682,  111,  186,  234,  303,
  467,  390,  605,  648,  673,  736,  529,  530,  110,  184,
  233,  295,  671,  644,  702,  758,  703,  784,  794,  795,
  114,  192,  237,  334,  120,  202,  203,  506,  722,  264,
};
short yysindex[] = {                                    324,
 -170,    0,   -3, -159, -123,  604,  -76,    0,  324,    0,
    0,    0, -198,   -4, -295,  599, -138,   27,    0,    0,
    0,   17,   22,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   50,  624,    0,    0,
 -106,  -31,    0,  198,    0,    0,    0,    0,   70,  839,
    0,    0,    0,    0,    0,    0,    0,  122,  136,  144,
  151,  156,    0,    0,  168,  179,    0,    0,    0,    0,
  640,    0,  231,  178,    0,    0, 1051,    0,    0,    0,
  101,  105,    0,  330,  334,    0,  216,    0,    0,    0,
    0,    0,    0,    0,    0,  217,    0,    0,    0,   -3,
   -3,   -3,   -3,   -3,    0,    0,    0,    0,    0,  352,
  291,  810,    0,    0,  -46,    0,   73,    0,    0,  788,
    0,    0,    0,    0,    0,    0,    0,    0,  788,  220,
  192,    0,    0,    0,    0,    0,    0,  370,  373,  383,
  390,  393,  860,    0,    0,    0,    0,    0,    0,    0,
    0,  227,    0,  133, -127,    0,  205,  203,  137, -127,
    0,    0,    0,  231,    0,    0,    0,    0,    0,    0,
 -102,  499,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  281,    0,  839, -124,    0,   32,    0,    0,
    0,  280,  288,  292,  225,   70,  839,  839,    0, -215,
    0, -250,  231, -250,   70, -250,    0,  839,  290, -144,
  839,   -2,  295,  314,  317,    0,    0,  320,    0,    0,
    0,  182,  -90,  -99,  222,  -16,  -62,    0,    0,  839,
  839,  221,  231,    0,  329,    0,    0,    0, -184, -215,
 -215,    0,    0,    0,  839,    0,    0,    0,  839,  319,
    0,  470,  341,   -6,    0,  476,  351,    0,    0,  355,
 -250,  356,    0,    0,    0,  839,  272,    0,    0,  357,
   -2,    0,    0,    0,    0,    0,    0,  358,  361,  220,
  319,  335,  675,    0,  371,  372,  220,  319,    0,  231,
  675,    0,  385,  389, -144,  220,  319,    0,    0,  839,
  839,    0,  675,    0,  391,  396,  517,  284,    0,  439,
  357,  231,  231,  883,    0,    0,  399,  403, -144,  220,
  839,  675,    0,  413,  101, 1016,    0,    0,    0,    0,
    0,  231,    0,    0,  415,  420,    0,    0,    0,    0,
    0,    0,    0,    0,   -6,  350,  561,   69,   -6,    0,
    0,    0,    0,  431,    0,  395,  220,    0,    0,    0,
    0,  272,    0,   16,  639,    0,    0,    0,    0,    0,
    0,  -13,    0,  675,    0,    0,    0,    0,    0,    0,
    0,    0,  675,    0,    0,  429,    0,    0,  839,  839,
    0,  675,    0,    0,    0,  231,  337,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  816,    0,    0,  582,    0,
    0,  342,    0,  839,    0,  675,    0,    0,  101,    0,
    0,    0,    4,  668,   15,   -6,  231,    0,    0,    0,
    0,  -61,    0,  220,    0,    0,  839,  839,    0,  451,
    0,    0,    0,    0,  414,    0,  521,  319,  319,  463,
    0,    0, -201,    0,  429,  202,    0,  231,    0,  883,
    0,    0,    0,    0,  342,  257,    0,  471,  807,    0,
  475,    0,    0,    0,    0,    0,  609,    0,    0,    0,
  611,  690,  480,    0,  481,  692,    0,    0,    0,  139,
  684,   70,  839,  319,  839,  220,   70,   70,    0,  487,
    0,    0,  489,  839,  357,  357,  675,    0,    0,    0,
    0,    0, -158,    0,    0,    0,    0,  492,  319,  220,
  292, -184,    0,  493,    0,    0,  112,    0,    0,    0,
    0,    0,    0,  257,    0,    0,    0,    0,    0,    0,
    0,    0,  205,  426, -127, -196, -196,  368, -196,  501,
  501,  501,    0,   44,    0,  231,    0,    0,    0, -206,
    0,    0,    0,    0,    0,  221,    0,  510,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -57,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  514, -144,  649,  424,  505,
  654, -121,    0,  530, -196,  231, -196,    0,  658,    0,
    0,   70,    0, -196, -196, -196,    0,    0,    0,    0,
    0,    0,    0,    0,  535,    0,    0,  543,    0,    0,
 -160,    0,  839,  319,    0,  839,    0,    0,    0,    0,
    0,    0, -196,    0,    0,    0, -196,    0,    0,    0,
  888,    0,  839,    0,  505,  691,  581,  457,    0,  547,
  302,  556,    0,  -24,    0,  839,  319,  839,  220,   70,
    0,  559,    0,    0,  357,    0,  231,  231,  231,    0,
  675,  703,    0,    0,  706,  735,    0,  573,    0,  589,
    0,    0,  231,  319,  590,    0,  592,    0,  593,    0,
  594,  692,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1001,  976,    0,  357,  357,
    0,    0,  357,  357,  598,  439,  532,  595,    0,    0,
  691,    0,    0,    0,    0,    0, -194,  -87,    0,  357,
  730,    0,  524,  603,    0,    0,    0,    0,    0,    0,
    0,  617,    0,  625,    0,    0,    0,    0,    0,  629,
    0,    0,    0,  630,    0,  839,  631,    0,  634,    0,
    0,    0,    0,  839,  736,    0,  635,  602,  528,    0,
    0,    0,    0,    0,  637,    0,  641,    0,    0,  888,
 -111,    0,    0,  644,    0,  650,    0,    0,    0,    0,
    0,
};
short yyrindex[] = {                                     20,
    0,    0,    0,    0,    0,    0, -191,    0,  113,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  651,    0,    0,
  655, -185,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -195,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  504,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  166,    0,
  186,    0,    0,    0,    0,    0,    0,  660,  664,  216,
  665,  667,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -79,    0,    0,  -98,    0,  513,  -54,    0,  -41,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   66,    0,    0,
    0,    0,    0,    0,  -72,    0,    0,    0,    0,  806,
    0,  808,    0,  808,    0,  808,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  671,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  806,
  806,    0,    0,    0,  127,    0,    0,    0,  -84,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  808,    0,    0,    0,    0,  473,    0,    0,    0,    0,
  677,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -180,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  417,  525,    0,    0,    0,    0,
    0,  -45,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -19,  -10,  -17,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  678,    0, -171,  369,    0,    0,    0,    0,    0,
    0,    0,    0,  -29,    0,    0,    0,    0,    0,    0,
    0,    0,  484,    0,    0,    0,    0,    0,  679,  682,
    0,  683,    0,    0,    0,    0,  688,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  689,    0,    0,    0,    0,
    0,    0,    0,  700,    0,  704,    0,    0,  417,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  727,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  707,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  361,  708,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   35,    0,    0,    0,
    0,  822,    0,    0,    0,    0,    0,    0,    0,  710,
  401,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  996,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  713,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -96,   40,  115, -234,  -81,   18,
   18,   18,    0,    0,    0,  823,    0,    0,    0,  714,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  718,
    0,    0,    0,    0,  -81,    0,  -81,    0,  719,    0,
    0,    0,    0,  -81,  -81,  -81,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -21,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -81,    0,    0,    0,  -81,    0,    0,    0,
  809,    0,    0,    0,  -21,  720,    0,    0,    0,    0,
    0,    0,    0,  805,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  722,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  724,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  720,    0,    0,    0,    0,    0,  725,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  728,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  738,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
short yygindex[] = {                                      0,
  138,    0,  422,    0,    0,  243,  259,    0,    0,    0,
  400, -271,  633,    0,    0,    0,    0,  394,    0,    0,
    0,  442,    0, -200,    0,  518,    0,    0,    0,    0,
    0,    0,  247,    0,    0, -625,    0,  236, -390, -581,
    0,  461,    0,  260,  294,    0,    0,    0,    0,    0,
  207,    0,    0, -359,    0,    0,    0,    0,    0,  523,
    0,    0,    0,  516,    0,  -66,  -78, -242, -204,    0,
 -310,  711, -272,    2,    0,    0,    0,    0,   47,    0,
    0,    0,  638,    0,  522,  890,    0,    0,  892,    0,
    0,    0,    0,  -47,    0,    0, -269,  -89,    0,  343,
 -150,  447,  -59,  491,    0, -227,    0, -211,  306, -173,
 -172,  223,  853,    0,   46,    0,  829, -251, -286, -154,
 -187,    0,    0,    0,    0,  121,    0,    0,    0,    0,
    0,  209,  622,   -7, -149,    0,    0, 1039,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  957,    0,    0,    0,    0,
    0,    0,    0,    0,  769,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  416,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  316,    0,    0,
    0,    0,  269,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  902,    0,    0,    0,
};
#define YYTABLESIZE 1377
short yytable[] = {                                      52,
  106,  141,  197,  201,  126,  262,  273,   45,  229,  230,
  412,   97,  268,  815,  339,  216,  125,  351,  396,    1,
  380,  535,  223,  537,  124,  302,  124,  388,  393,  539,
  539,  197,  201,  355,  294,  539,  397,  783,  127,  354,
  402,  486,  432,  236,  140,  262,  262,  348,  381,   45,
  510,  197,  201,  336,  260,  389,  252,  256,   50,  436,
  433,  490,  333,  504,  398,   20,  481,  647,  515,  252,
  256,   25,  679,  260,  124,  260,  190,  513,  101,  102,
  748,  124,   45,  444,  439,  111,   19,  490,  140,  252,
  256,   58,  522,  363,   82,  126,  518,  455,  490,   23,
  720,  233,   59,   60,  252,  256,  537,  217,  325,  654,
  448,  449,    2,  539,   98,   50,   99,  100,  101,  102,
  546,  774,  399,  400,  348,  252,  256,  123,  490,  111,
  111,  450,  752,   24,  126,  239,  675,  657,  207,  606,
  124,  240,  607,  434,  814,  265,  269,   98,   50,   99,
  100,  101,  102,  219,  252,  256,  296,  529,  251,  103,
  124,  278,  486,  220,  126,  289,  208,  271,  780,  241,
  126,  124,  127,  124,  500,  486,  340,  534,  252,  256,
  261,  126,  269,   50,  507,  127,  190,  348,  348,  639,
  236,  447,  103,  328,  503,  297,  298,  510,  645,  628,
  221,  777,   54,  329,  290,  291,  490,  490,  490,  299,
  127,  513,  126,  342,  602,  603,  300,   20,  292,  126,
  781,  126,  348,   25,  513,  531,  532,  363,  126,  490,
  523,  719,  330,  391,  519,  233,  623,  486,  363,  316,
  515,  410,  363,  126,  126,  438,  596,   73,  539,  125,
  646,  236,   96,  124,  393,  413,  415,  658,  659,  488,
  676,  317,   56,  126,  363,  363,  318,  175,  275,  331,
  612,  594,  489,   78,  124,  440,  176,  363,   79,  195,
  363,  363,  363,  363,  705,  335,   95,  124,   20,   21,
  363,  529,  363,  363,  363,  363,  486,  124,  222,  124,
  347,  579,   83,  595,  529,  301,   80,  461,  535,  782,
  537,  127,  411,  457,  293,  458,  236,  539,  634,  635,
  636,  347,  469,  510,  319,  428,  543,  126,   96,  529,
  651,  469,  581,  582,  270,  469,  272,  320,  138,  477,
  493,  515,  332,  494,  495,  138,  314,  321,  322,  487,
  513,  323,  363,  138,  124,  197,  201,  138,  339,  469,
  469,  142,  591,  593,  172,  173,  524,  616,  126,  493,
  520,  486,  494,  197,  201,  363,   85,  617,  115,   95,
  502,  279,  280,  125,  729,  466,  462,   87,  324,  126,
  126,  364,  116,  138,  466,  140,  125,  508,  509,  126,
  117,  463,  464,  466,  244,  386,   59,  118,  403,  403,
  627,  545,  119,  124,  496,   75,   76,   59,   59,  726,
   72,  125,   80,  242,  243,  663,  716,  428,  765,  766,
  529,  138,  767,  768,  128,  126,  121,  466,  138,  585,
  586,  525,   81,  496,  724,  521,  138,  122,   80,  785,
  138,  618,  144,  619,  620,  621,  145,  538,  345,  346,
  126,  469,  469,  126,  589,  536,  252,  256,   81,  597,
  598,  539,  146,  147,  153,  269,  725,  304,  177,   98,
   87,  428,  174,  101,  102,  179,  138,  305,  622,  124,
  640,  500,  183,  101,  102,  185,  540,  126,  386,   59,
  541,  403,  403,  711,  712,  187,   88,   89,   90,  638,
   59,   59,  189,   72,  125,  191,  306,  307,  308,  309,
  125,  125,  125,  501,  337,  204,  197,  201,  125,   91,
  206,  211,  542,  213,  215,  591,  593,  238,   98,   50,
   99,  100,  101,  102,  246,  366,  274,  126,  581,  582,
  247,  283,  778,  310,  311,  249,  194,  715,  312,  269,
   98,   50,   99,  100,  101,  102,  367,   80,   80,   80,
  284,  197,  201,  285,  799,  126,  286,  124,  287,    1,
    2,  101,  102,  103,  667,  341,  799,   81,   81,   81,
   80,  349,  352,  678,  154,  129,  680,  353,  361,   88,
   89,   90,    3,    4,    5,  103,  318,  362,  126,  155,
   81,  363,  365,  704,  378,  375,  156,  379,  126,  126,
  126,  680,   91,  228,  157,  500,  313,  386,  387,  158,
  731,  731,  733,  382,  126,  126,  500,  817,  818,  405,
  500,  394,  727,  528,  549,  395,  415,  403,  788,  406,
  550,  551,  404,  368,  369,  430,  773,  501,  552,  431,
  197,  201,  500,  500,  159,  370,  371,  410,  501,  437,
  195,  441,  501,  490,  500,  500,  442,  445,  500,  500,
  500,  500,  500,  500,  446,  500,  500,  453,  500,  454,
  500,  500,  500,  500,  501,  501,  460,  408,   50,  468,
  469,  101,  102,  478,  482,  709,  501,  501,  492,  511,
  501,  501,  501,  501,  501,  501,  483,  501,  501,  512,
  501,  533,  501,  501,  501,  501,  806,  555,    6,  129,
    7,  573,  574,  576,  802,  575,  577,  578,  411,  470,
  318,  588,  129,  129,  129,  599,  129,  600,  609,  615,
  500,  318,  500,  500,  225,  318,  626,   98,   50,   99,
  100,  101,  102,  471,  472,  632,  207,  129,  643,  129,
  649,  652,  653,  500,  654,  226,  656,  318,  318,  787,
  665,  124,  501,  129,  501,  501,  661,  772,  513,  318,
  318,  672,  514,  318,  318,  318,  318,  318,  318,  674,
  318,  318,  103,  227,  490,  501,  713,  129,  129,  473,
  490,  490,  718,  706,  515,  516,  714,  728,  490,  124,
  148,  149,  150,  151,  152,  735,  517,  518,  737,  749,
  519,  520,  521,  522,  523,  524,  708,  525,  526,   98,
   50,   99,  100,  101,  102,  750,  753,  129,  754,  755,
  756,  775,  786,  129,  129,  129,  769,  805,  803,  790,
   98,   50,   99,  100,  101,  102,  129,  129,  739,  740,
  760,  761,   25,  791,  741,  742,  739,  740,   26,   27,
  808,  792,  741,  742,  103,  793,  796,  800,  318,  195,
  801,  804,   25,  812,  743,  744,  745,  813,   26,   27,
  820,  746,  743,  744,  745,  103,  821,   30,   25,  746,
  364,   27,  124,   22,   26,   27,  322,   62,  124,  124,
  282,  177,   28,  373,   63,  527,  124,   67,  486,   29,
  490,  331,   64,  101,  102,  158,   65,   30,  159,  173,
  732,   31,   28,   25,  192,  183,  547,  548,  604,   29,
   98,   50,   99,  100,  101,  102,  380,   30,   28,  734,
  385,   31,  625,  157,  393,   29,  104,  637,  226,  392,
  490,  195,   66,   30,  233,  443,  212,   31,  217,   32,
  297,  486,   33,  614,  256,  418,  418,  418,  418,  418,
  418,  451,  537,   28,  339,  103,  227,  776,  789,   32,
   29,  613,  554,  418,  807,  771,  751,  548,   30,  456,
  568,  169,   31,  171,  601,   32,   34,   35,   36,   37,
   38,   39,   40,   41,   42,   43,   44,  757,  723,   81,
  418,  418,  642,  819,  231,  255,   34,   35,   36,   37,
   38,   39,   40,   41,   42,   43,   44,   53,  143,  377,
   32,  759,   34,   35,   36,   37,   38,   39,   40,   41,
   42,   43,   44,  448,  448,  448,  448,  448,  448,  129,
  810,  556,  131,  132,  133,  134,  135,  136,  137,  739,
  740,  448,  195,  557,   25,  741,  742,   34,   35,   36,
   37,   38,   39,   40,   41,   42,  717,   98,   50,   99,
  100,  101,  102,  245,  579,  743,  744,  745,  448,  448,
  154,    0,  746,  154,    0,  193,    0,  418,   98,   50,
   99,  100,  101,  102,    0,  155,    0,    0,  167,    0,
    0,    0,  156,    0,   28,  156,  194,    0,    0,  418,
  558,   29,  103,  157,  559,  560,    0,    0,  168,   30,
    0,   25,    0,   31,    0,  686,    0,    0,    0,  687,
    0,    0,    0,  103,    0,    0,    0,    0,    0,    0,
  416,  417,  418,  419,  420,  421,  422,  423,  424,    0,
    0,  688,  689,  159,  425,    0,    0,    0,  631,    0,
  633,   32,  561,    0,  690,  448,    0,  691,  692,  693,
  694,   28,    0,    0,    0,    0,    0,  695,   29,  696,
  697,  698,  699,    0,    0,    0,   30,  448,    0,    0,
   31,  480,    0,    0,    0,  562,    0,    0,   34,   35,
   36,   37,   38,   39,   40,   41,   42,  416,  417,  418,
  419,  420,  421,  422,  423,  424,  662,    0,  664,    0,
  195,  425,  168,    0,    0,  668,  669,  670,   32,    0,
    0,    0,    0,    0,    0,    0,  168,  168,  513,  700,
    0,    0,  514,    0,   98,   50,   99,  100,  101,  102,
    0,  207,    0,    0,  683,    0,    0,    0,  685,    0,
    0,    0,  701,    0,  515,   34,   35,   36,   37,   38,
   39,   40,   41,   42,    0,    0,  168,    0,    0,    0,
  519,    0,  521,  522,    0,  524,    0,  525,  526,  103,
  739,  740,  760,  761,    0,    0,  741,  742,    0,    0,
  168,  168,  129,    0,  130,  131,  132,  133,  134,  135,
  136,  137,    0,    0,    0,    0,  743,  744,  745,    0,
    0,    0,    0,  746,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  168,
};
short yycheck[] = {                                       7,
   60,   91,  153,  153,   83,  210,  218,    6,  182,  182,
  321,   59,  213,  125,  242,  170,   83,  260,  305,    0,
  290,   41,  125,   41,  123,  125,  123,  297,  301,   40,
   41,  182,  182,   40,  125,   46,  306,  125,  123,   46,
  313,  123,  329,  123,  295,  250,  251,  259,  291,   48,
  123,  202,  202,  241,  270,  298,  207,  207,  260,  332,
  330,  257,  125,  125,  307,  257,  426,  125,  123,  220,
  220,  257,  654,  270,  259,  270,  257,  123,  263,  264,
  706,  123,   81,  355,  336,  257,  257,  283,  295,  240,
  240,  387,  327,  123,   48,  174,  331,  367,  294,  259,
  125,  123,  398,  399,  255,  255,  124,  174,  125,  270,
   42,   43,    0,  124,  259,  260,  261,  262,  263,  264,
  480,  747,  310,  311,  336,  276,  276,   81,  125,  301,
  302,   63,  714,  257,  213,  195,  297,  259,  266,  298,
  123,  266,  301,  331,  256,  396,  213,  259,  260,  261,
  262,  263,  264,  256,  305,  305,  256,  123,  206,  304,
  257,  221,  123,  266,  243,  256,  294,  215,  256,  294,
  249,  270,  257,  270,  446,  257,  243,  379,  329,  329,
  396,  260,  249,  260,  454,  270,  367,  399,  400,  396,
  270,  123,  304,  256,  256,  295,  296,  270,  256,  396,
  303,  396,  401,  266,  295,  296,  402,  403,  404,  309,
  295,  257,  291,  398,  525,  526,  316,  409,  309,  298,
  308,  300,  434,  409,  270,  468,  469,  257,  307,  425,
  327,  256,  295,  300,  331,  257,  125,  123,  268,  256,
  295,  320,  272,  322,  323,  335,  516,  386,  259,  123,
  308,  331,  259,  295,  527,  322,  323,  379,  380,  256,
  651,  278,  267,  342,  294,  295,  283,  130,  413,  332,
  540,  514,  269,  257,  257,  342,  139,  307,  257,  391,
  310,  311,  312,  313,  675,  240,  267,  270,  292,  293,
  320,  257,  322,  323,  324,  325,  257,  396,  401,  396,
  255,  413,  409,  515,  270,  405,  257,  321,  328,  397,
  328,  396,  320,  298,  405,  300,  396,  328,  570,  571,
  572,  276,  257,  396,  341,  324,  125,  406,  259,  295,
  617,  266,  506,  506,  214,  270,  216,  354,  319,  406,
  326,  396,  405,  329,  330,  326,  125,  364,  365,  439,
  396,  368,  382,  334,  396,  506,  506,  338,  586,  294,
  295,  257,  513,  513,  411,  412,  327,  256,  447,  326,
  331,  257,  329,  524,  524,  405,  408,  266,  257,  267,
  447,  384,  385,  257,  695,  384,  400,  283,  405,  468,
  469,  271,  257,  374,  393,  295,  270,  457,  458,  478,
  257,  415,  416,  402,  125,  386,  387,  257,  389,  390,
  565,  478,  257,  396,  400,  389,  390,  398,  399,  689,
  401,  295,  257,  392,  393,  626,  125,  426,  739,  740,
  396,  319,  743,  744,  257,  514,  269,  436,  326,  301,
  302,  327,  257,  400,  687,  331,  334,  269,  283,  760,
  338,  340,  123,  342,  343,  344,  123,  256,  250,  251,
  539,  396,  397,  542,  512,  473,  617,  617,  283,  517,
  518,  270,  257,  257,  123,  542,  688,  256,  259,  259,
  283,  480,  410,  263,  264,  294,  374,  266,  377,  259,
  580,  123,  123,  263,  264,  123,  295,  576,  386,  387,
  299,  389,  390,  677,  677,  123,  402,  403,  404,  576,
  398,  399,  123,  401,  388,  123,  295,  296,  297,  298,
  394,  395,  396,  123,  304,  299,  677,  677,  402,  425,
  398,  327,  331,  331,  398,  686,  686,  257,  259,  260,
  261,  262,  263,  264,  257,  274,  257,  626,  722,  722,
  259,  257,  757,  332,  333,  331,  277,  256,  337,  626,
  259,  260,  261,  262,  263,  264,  295,  402,  403,  404,
  257,  722,  722,  257,  786,  654,  257,  259,  397,  256,
  257,  263,  264,  304,  632,  257,  798,  402,  403,  404,
  425,  273,  123,  653,  304,  123,  656,  257,  123,  402,
  403,  404,  279,  280,  281,  304,  123,  257,  687,  319,
  425,  257,  257,  673,  257,  259,  326,  257,  697,  698,
  699,  681,  425,  125,  334,  257,  405,  257,  257,  339,
  697,  698,  699,  299,  713,  714,  268,  811,  811,  123,
  272,  257,  690,  123,  388,  257,  713,  257,  125,  366,
  394,  395,  257,  382,  383,  257,  125,  257,  402,  257,
  811,  811,  294,  295,  374,  394,  395,  746,  268,  257,
  391,  257,  272,  257,  306,  307,  257,  328,  310,  311,
  312,  313,  314,  315,  124,  317,  318,  257,  320,  295,
  322,  323,  324,  325,  294,  295,   58,  259,  260,  271,
  272,  263,  264,  367,  123,  125,  306,  307,   41,  259,
  310,  311,  312,  313,  314,  315,  375,  317,  318,  306,
  320,  259,  322,  323,  324,  325,  125,  257,  405,  257,
  407,  257,  124,   44,  794,  125,  257,  257,  746,  311,
  257,   58,  270,  271,  272,  259,  274,  259,  257,  257,
  382,  268,  384,  385,  256,  272,  331,  259,  260,  261,
  262,  263,  264,  335,  336,  398,  266,  295,  259,  297,
  257,  123,  349,  405,  270,  277,  123,  294,  295,  256,
  123,  257,  382,  311,  384,  385,  257,  256,  268,  306,
  307,  257,  272,  310,  311,  312,  313,  314,  315,  257,
  317,  318,  304,  305,  388,  405,  350,  335,  336,  381,
  394,  395,  257,  123,  294,  295,  270,  259,  402,  295,
  110,  111,  112,  113,  114,  123,  306,  307,  123,  257,
  310,  311,  312,  313,  314,  315,  256,  317,  318,  259,
  260,  261,  262,  263,  264,  257,  257,  375,  257,  257,
  257,  257,  123,  381,  382,  383,  259,  256,  123,  257,
  259,  260,  261,  262,  263,  264,  394,  395,  345,  346,
  347,  348,  269,  257,  351,  352,  345,  346,  275,  276,
  353,  257,  351,  352,  304,  257,  257,  257,  405,  391,
  257,  257,  269,  257,  371,  372,  373,  257,  275,  276,
  257,  378,  371,  372,  373,  304,  257,  257,  269,  378,
  398,  257,  388,  410,  275,  276,  257,  319,  394,  395,
  257,  257,  319,  257,  326,  405,  402,  257,  123,  326,
  123,  123,  334,  257,  257,  257,  338,  334,  257,  257,
  698,  338,  319,  269,  257,  257,  125,  125,  527,  326,
  259,  260,  261,  262,  263,  264,  257,  334,  319,  701,
  257,  338,  563,  257,  257,  326,  257,  574,  277,  257,
  257,  391,  374,  334,  257,  257,  257,  338,  257,  376,
  257,  257,  379,  542,  257,  259,  260,  261,  262,  263,
  264,  359,  475,  319,  257,  304,  305,  751,  763,  376,
  326,  541,  487,  277,  798,  746,  713,  485,  334,  372,
  489,  122,  338,  122,  524,  376,  413,  414,  415,  416,
  417,  418,  419,  420,  421,  422,  423,  722,  686,  406,
  304,  305,  586,  811,  182,  207,  413,  414,  415,  416,
  417,  418,  419,  420,  421,  422,  423,    9,   92,  281,
  376,  736,  413,  414,  415,  416,  417,  418,  419,  420,
  421,  422,  423,  259,  260,  261,  262,  263,  264,  282,
  802,  265,  285,  286,  287,  288,  289,  290,  291,  345,
  346,  277,  391,  277,  269,  351,  352,  413,  414,  415,
  416,  417,  418,  419,  420,  421,  681,  259,  260,  261,
  262,  263,  264,  202,  413,  371,  372,  373,  304,  305,
  304,   -1,  378,  304,   -1,  256,   -1,  391,  259,  260,
  261,  262,  263,  264,   -1,  319,   -1,   -1,  319,   -1,
   -1,   -1,  326,   -1,  319,  326,  277,   -1,   -1,  413,
  334,  326,  304,  334,  338,  339,   -1,   -1,  339,  334,
   -1,  269,   -1,  338,   -1,  268,   -1,   -1,   -1,  272,
   -1,   -1,   -1,  304,   -1,   -1,   -1,   -1,   -1,   -1,
  355,  356,  357,  358,  359,  360,  361,  362,  363,   -1,
   -1,  294,  295,  374,  369,   -1,   -1,   -1,  567,   -1,
  569,  376,  386,   -1,  307,  391,   -1,  310,  311,  312,
  313,  319,   -1,   -1,   -1,   -1,   -1,  320,  326,  322,
  323,  324,  325,   -1,   -1,   -1,  334,  413,   -1,   -1,
  338,  406,   -1,   -1,   -1,  419,   -1,   -1,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  625,   -1,  627,   -1,
  391,  369,  257,   -1,   -1,  634,  635,  636,  376,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  271,  272,  268,  382,
   -1,   -1,  272,   -1,  259,  260,  261,  262,  263,  264,
   -1,  266,   -1,   -1,  663,   -1,   -1,   -1,  667,   -1,
   -1,   -1,  405,   -1,  294,  413,  414,  415,  416,  417,
  418,  419,  420,  421,   -1,   -1,  311,   -1,   -1,   -1,
  310,   -1,  312,  313,   -1,  315,   -1,  317,  318,  304,
  345,  346,  347,  348,   -1,   -1,  351,  352,   -1,   -1,
  335,  336,  282,   -1,  284,  285,  286,  287,  288,  289,
  290,  291,   -1,   -1,   -1,   -1,  371,  372,  373,   -1,
   -1,   -1,   -1,  378,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  381,
};
#define YYFINAL 8
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 425
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','",0,"'.'",0,0,0,0,0,0,0,0,0,0,0,"':'",0,
0,0,0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'",0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"L_EOS","L_ERROR","L_NUMBER","L_STRING","L_HNAME","L_KEYWORD",
"L_HEXSTRING","L_OCTETSTRING","T_DIRECT","T_INTERFACE","T_INTERFACES",
"T_LCLADDR","T_PROTO","T_METRIC","T_METRICIN","T_METRICOUT","T_INFINITY",
"T_DOWN","T_PARSE","T_ADV","T_DEFAULT","T_DEFAULTS","T_YYDEBUG","T_YYSTATE",
"T_YYQUIT","T_DEBUG","T_SYSLOG","T_UPTO","T_EMERG","T_ALERT","T_CRIT","T_ERR",
"T_WARNING","T_NOTICE","T_INFO","T_ON","T_OFF","T_GATEWAY","T_PREFERENCE",
"T_DEFAULTMETRIC","T_NONBROADCAST","T_BROADCAST","T_TYPE","T_POINTOPOINT",
"T_MULTICAST","T_NETMASK","T_DEFINE","T_NOP","T_NOP1","T_PEERAS","T_LOCALAS",
"T_NEIGHBOR","T_GROUP","T_NOGENDEFAULT","T_VERSION","T_DEFAULTIN",
"T_DEFAULTOUT","T_MAXUP","T_SOURCENET","T_PKTSIZE","T_P1","T_P2","T_BGP",
"T_HOLDTIME","T_TEST","T_KEEPALL","T_SENDBUF","T_RECVBUF","T_SPOOLBUF","T_EGP",
"T_ASPATH","T_ORIGIN","T_INCOMPLETE","T_ANY","T_TAG","T_TRUSTEDGATEWAYS",
"T_SOURCEGATEWAYS","T_RIP","T_NORIPOUT","T_NORIPIN","T_NOCHECKZERO","T_OSPF",
"T_OSPF_ASE","T_NETWORKS","T_BACKBONE","T_VIRTUALLINK","T_STUB","T_STUBHOSTS",
"T_RXMITINTERVAL","T_INFTRANSDELAY","T_POLLINTERVAL","T_ROUTERS","T_NEIGHBORID",
"T_TRANSITAREA","T_ENABLE","T_DISABLE","T_ELIGIBLE","T_MONITORAUTHKEY","T_DD",
"T_REQUEST","T_LSU","T_ACK","T_RECEIVE","T_LSA_BLD","T_LSA_RX","T_LSA_TX",
"T_TRAP","T_EXPORTINTERVAL","T_EXPORTLIMIT","T_FIRST","T_EVERY","T_AREA",
"T_SPF","T_HELLO","T_HELLOINTERVAL","T_ROUTERDEADINTERVAL","T_PRIORITY",
"T_REDIRECT","T_NOREDIRECTS","T_ICMP","T_AUTHTYPE","T_AUTHKEY","T_NONE",
"T_SIMPLE","T_AUTH","T_PASSIVE","T_SIMPLEX","T_STRICTIFS","T_SCANINTERVAL",
"T_STATIC","T_MARTIANS","T_RETAIN","T_EXPORT","T_IMPORT","T_HOST","T_MASK",
"T_MASKLEN","T_REJECT","T_BLACKHOLE","T_RESTRICT","T_ALLOW","T_AS","T_ROUTERID",
"T_IGP","T_OPTIONS","T_NOINSTALL","T_NOSEND","T_NORESOLV","T_TRACEOPTIONS",
"T_EXCEPT","T_TRACEFILE","T_REPLACE","T_SIZE","T_FILES","T_K","T_M","T_ALL",
"T_GENERAL","T_INTERNAL","T_EXTERNAL","T_ROUTE","T_UPDATE","T_KERNEL","T_TASK",
"T_TIMER","T_NOSTAMP","T_MARK","T_INET","T_GENDEFAULT",
};
char *yyrule[] = {
"$accept : config",
"config :",
"config : statements",
"statements : statement",
"statements : statements statement",
"statement : parse_statement",
"statement : trace_statement",
"statement : option_order option_statement",
"statement : interface_order interface_statement",
"statement : define_order define_statement",
"statement : proto_order proto_statement",
"statement : route_order route_statement",
"statement : control_order control_statement",
"statement : error L_EOS",
"statement : L_EOS",
"parse_statement : T_YYDEBUG onoff_option L_EOS",
"parse_statement : T_YYSTATE L_NUMBER L_EOS",
"parse_statement : T_YYQUIT L_EOS",
"trace_statement : T_TRACEOPTIONS trace_trace_options_none L_EOS",
"trace_statement : T_TRACEFILE trace_file trace_limits L_EOS",
"trace_file :",
"trace_file : string trace_replace",
"trace_size : number",
"trace_size : number T_K",
"trace_size : number T_M",
"trace_replace :",
"trace_replace : T_REPLACE",
"trace_limits :",
"trace_limits : T_SIZE trace_size T_FILES number",
"trace_trace_options_none : T_NONE",
"trace_trace_options_none : trace_trace_options",
"trace_trace_options : trace_trace_option",
"trace_trace_options : trace_trace_options trace_trace_option",
"trace_trace_options : trace_trace_options T_EXCEPT trace_trace_option",
"trace_trace_option : trace_option",
"trace_trace_option : trace_option_global",
"trace_options_none : T_NONE",
"trace_options_none : trace_options",
"trace_options : trace_option",
"trace_options : trace_options trace_option",
"trace_option_global : T_NOSTAMP",
"trace_option_global : T_MARK",
"trace_option_global : T_PARSE",
"trace_option_global : T_ADV",
"trace_option : T_ALL",
"trace_option : T_GENERAL",
"trace_option : T_INTERNAL",
"trace_option : T_EXTERNAL",
"trace_option : T_ROUTE",
"trace_option : T_UPDATE",
"trace_option : T_TASK",
"trace_option : T_TIMER",
"trace_option : T_PROTO",
"trace_option : T_KERNEL",
"trace_option : T_BGP",
"trace_option : T_EGP",
"trace_option : T_ICMP",
"trace_option : T_OSPF",
"trace_option : T_RIP",
"define_order :",
"$$1 :",
"define_statement : T_MARTIANS $$1 '{' martian_list '}' L_EOS",
"define_statement : T_AS as L_EOS",
"define_statement : T_ROUTERID host L_EOS",
"martian_list :",
"martian_list : martian_list martian martian_option L_EOS",
"martian_list : martian_list error L_EOS",
"martian_option :",
"martian_option : T_ALLOW",
"martian : host_mask",
"martian : network_mask",
"martian : default_mask",
"option_order :",
"option_statement : T_OPTIONS option_list L_EOS",
"option_list : option",
"option_list : option_list option",
"option : T_NOINSTALL",
"option : T_GENDEFAULT preference_option default_gateway_option",
"option : T_NOSEND",
"option : T_NORESOLV",
"option : T_SYSLOG syslog_mask",
"default_gateway_option :",
"$$2 :",
"default_gateway_option : T_GATEWAY $$2 gateway",
"syslog_mask : syslog_level",
"syslog_mask : T_UPTO syslog_level",
"syslog_mask : syslog_mask syslog_level",
"syslog_level : T_EMERG",
"syslog_level : T_ALERT",
"syslog_level : T_CRIT",
"syslog_level : T_ERR",
"syslog_level : T_WARNING",
"syslog_level : T_NOTICE",
"syslog_level : T_INFO",
"syslog_level : T_DEBUG",
"interface_order :",
"$$3 :",
"interface_statement : T_INTERFACES $$3 '{' interface_stmts '}' L_EOS",
"interface_stmts :",
"interface_stmts : interface_stmts interface_stmt L_EOS",
"interface_stmts : interface_stmts error L_EOS",
"interface_stmt : T_OPTIONS interface_options",
"interface_stmt : T_INTERFACE interface_all_list interface_define_options",
"$$4 :",
"interface_stmt : T_DEFINE host $$4 interface_type_options interface_common_options",
"interface_options : interface_option",
"interface_options : interface_options interface_option",
"interface_option : T_STRICTIFS",
"interface_option : T_SCANINTERVAL time",
"interface_type_options : T_BROADCAST host",
"interface_type_options : T_POINTOPOINT host",
"interface_type_options :",
"interface_common_options :",
"interface_common_options : interface_common_options interface_common_option",
"interface_common_option : T_NETMASK mask",
"interface_common_option : T_MULTICAST",
"interface_define_options : interface_define_option",
"interface_define_options : interface_define_options interface_define_option",
"interface_define_option : T_PREFERENCE preference",
"interface_define_option : T_DOWN T_PREFERENCE preference",
"interface_define_option : T_PASSIVE",
"interface_define_option : T_SIMPLEX",
"interface_define_option : T_REJECT",
"interface_define_option : T_BLACKHOLE",
"interface_list_option :",
"interface_list_option : T_INTERFACE interface_list",
"interface_gateway_list : interface_list_option",
"interface_gateway_list : T_GATEWAY gateway_list",
"interface_all_list : T_ALL",
"interface_all_list : interface_list",
"interface_list : interface_all",
"interface_list : interface_list interface_all",
"interface_all : interface_all_adv",
"interface_all_adv : host_name",
"interface_all_adv : addr",
"interface_local : interface_addr",
"interface_addr : addr",
"interface_addr : host_name",
"proto_order :",
"proto_statement : redirect_statement L_EOS",
"proto_statement : bgp_statement L_EOS",
"proto_statement : egp_statement L_EOS",
"proto_statement : ospf_statement L_EOS",
"proto_statement : rip_statement L_EOS",
"$$5 :",
"rip_statement : T_RIP $$5 onoff_option rip_group",
"rip_group :",
"rip_group : '{' rip_group_stmts '}'",
"rip_group_stmts :",
"rip_group_stmts : rip_group_stmts rip_group_stmt L_EOS",
"rip_group_stmts : rip_group_stmts error L_EOS",
"rip_group_stmt : T_PREFERENCE preference",
"rip_group_stmt : T_DEFAULTMETRIC metric",
"rip_group_stmt : T_BROADCAST",
"rip_group_stmt : T_NONBROADCAST",
"rip_group_stmt : T_TRACEOPTIONS rip_trace_options",
"rip_group_stmt : T_NOCHECKZERO",
"rip_group_stmt : T_INTERFACE interface_all_list rip_interface_options",
"rip_group_stmt : T_TRUSTEDGATEWAYS gateway_list",
"rip_group_stmt : T_SOURCEGATEWAYS gateway_list",
"rip_interface_options : rip_interface_option",
"rip_interface_options : rip_interface_options rip_interface_option",
"rip_interface_option : T_NORIPIN",
"rip_interface_option : T_NORIPOUT",
"rip_interface_option : T_METRICIN metric",
"rip_interface_option : T_METRICOUT metric",
"rip_interface_option : T_AUTH rip_auth",
"rip_interface_option : T_VERSION L_NUMBER rip_v2_options",
"rip_v2_options :",
"rip_v2_options : T_MULTICAST",
"rip_v2_options : T_BROADCAST",
"rip_auth : T_NONE",
"rip_auth : string",
"rip_trace_options : trace_options",
"rip_prop_init : T_RIP",
"$$6 :",
"ospf_statement : T_OSPF $$6 onoff_option ospf_group",
"ospf_group :",
"ospf_group : '{' ospf_group_stmts '}'",
"ospf_group_stmts :",
"ospf_group_stmts : ospf_group_stmts ospf_group_stmt L_EOS",
"ospf_group_stmts : ospf_group_stmts error L_EOS",
"ospf_group_stmt : T_DEFAULTS '{' ospf_defaults '}'",
"ospf_group_stmt : T_TRACEOPTIONS ospf_trace_options",
"ospf_group_stmt : T_EXPORTINTERVAL time",
"ospf_group_stmt : T_EXPORTLIMIT number",
"ospf_group_stmt : T_MONITORAUTHKEY ospf_auth_key",
"ospf_group_stmt : T_SYSLOG ospf_syslog_first ospf_syslog_every",
"$$7 :",
"ospf_group_stmt : ospf_area_option $$7 '{' ospf_area_stmts '}'",
"ospf_syslog_first :",
"ospf_syslog_first : T_FIRST number",
"ospf_syslog_every :",
"ospf_syslog_every : T_EVERY number",
"ospf_defaults :",
"ospf_defaults : ospf_defaults ospf_default L_EOS",
"ospf_defaults : ospf_defaults error L_EOS",
"ospf_default : T_PREFERENCE preference",
"ospf_default : T_METRIC ospf_cost",
"ospf_default : T_TAG tag_as",
"ospf_default : T_TYPE ospf_type",
"ospf_area_stmts :",
"ospf_area_stmts : ospf_area_stmts ospf_area_stmt L_EOS",
"ospf_area_stmts : ospf_area_stmts error L_EOS",
"ospf_area_stmt : T_AUTHTYPE ospf_auth_type",
"ospf_area_stmt : T_STUB ospf_cost_option",
"ospf_area_stmt : T_STUBHOSTS '{' ospf_stub_list '}'",
"ospf_area_stmt : T_NETWORKS '{' ospf_area_range_list '}'",
"ospf_area_stmt : T_INTERFACE ospf_interface",
"ospf_area_stmt : T_VIRTUALLINK T_NEIGHBORID host T_TRANSITAREA ospf_area ospf_common",
"ospf_interface : interface_all_list ospf_cost_option ospf_common",
"ospf_interface : interface_all_list T_NONBROADCAST ospf_cost_option ospf_nonbroadcast",
"ospf_common :",
"ospf_common : '{' ospf_common_options '}'",
"ospf_common_options : ospf_common_option L_EOS",
"ospf_common_options : ospf_common_options ospf_common_option L_EOS",
"ospf_common_options : ospf_common_options error L_EOS",
"ospf_nonbroadcast :",
"ospf_nonbroadcast : '{' ospf_nonbroadcast_options '}'",
"ospf_nonbroadcast_options : ospf_nonbroadcast_option L_EOS",
"ospf_nonbroadcast_options : ospf_nonbroadcast_options ospf_nonbroadcast_option L_EOS",
"ospf_nonbroadcast_options : ospf_nonbroadcast_options error L_EOS",
"ospf_common_option : T_ENABLE",
"ospf_common_option : T_DISABLE",
"ospf_common_option : T_RXMITINTERVAL time",
"ospf_common_option : T_INFTRANSDELAY time",
"ospf_common_option : T_PRIORITY ospf_priority",
"ospf_common_option : T_HELLOINTERVAL time",
"ospf_common_option : T_ROUTERDEADINTERVAL time",
"ospf_common_option : T_AUTHKEY ospf_auth_key",
"ospf_nonbroadcast_option : ospf_common_option",
"ospf_nonbroadcast_option : T_POLLINTERVAL time",
"ospf_nonbroadcast_option : T_ROUTERS '{' ospf_router_eligible_list '}'",
"ospf_cost_option :",
"ospf_cost_option : T_METRIC ospf_cost",
"ospf_cost : metric",
"ospf_type_option :",
"ospf_type_option : T_TYPE ospf_type",
"ospf_type : L_NUMBER",
"ospf_area_option : T_AREA ospf_area",
"ospf_area_option : T_BACKBONE",
"ospf_area : number",
"ospf_auth_type : L_NUMBER",
"ospf_auth_type : T_NONE",
"ospf_auth_type : T_SIMPLE",
"ospf_auth_key : string",
"ospf_auth_key : L_NUMBER",
"ospf_auth_key : byte_string",
"ospf_stub_list : ospf_stub L_EOS",
"ospf_stub_list : ospf_stub_list ospf_stub L_EOS",
"ospf_stub_list : ospf_stub_list error L_EOS",
"ospf_stub : host T_METRIC ospf_cost",
"ospf_router_eligible_list : ospf_router_eligible L_EOS",
"ospf_router_eligible_list : ospf_router_eligible_list ospf_router_eligible L_EOS",
"ospf_router_eligible_list : ospf_router_eligible_list error L_EOS",
"ospf_router_eligible : gateway ospf_eligible_option",
"ospf_eligible_option :",
"ospf_eligible_option : T_ELIGIBLE",
"ospf_priority : L_NUMBER",
"ospf_prop_init : T_OSPF",
"ospf_ase_prop_init : T_OSPF_ASE",
"ospf_trace_options : ospf_trace_option",
"ospf_trace_options : ospf_trace_options ospf_trace_option",
"ospf_trace_options : ospf_trace_options T_EXCEPT ospf_trace_option",
"ospf_area_range_list :",
"ospf_area_range_list : ospf_area_range_list ospf_area_range L_EOS",
"ospf_area_range_list : ospf_area_range_list error L_EOS",
"ospf_area_range : host_mask",
"ospf_area_range : network_mask",
"ospf_trace_option : trace_option",
"ospf_trace_option : T_DD",
"ospf_trace_option : T_REQUEST",
"ospf_trace_option : T_LSU",
"ospf_trace_option : T_ACK",
"ospf_trace_option : T_RECEIVE",
"ospf_trace_option : T_LSA_BLD",
"ospf_trace_option : T_LSA_TX",
"ospf_trace_option : T_LSA_RX",
"ospf_trace_option : T_SPF",
"ospf_trace_option : T_TRAP",
"$$8 :",
"egp_statement : T_EGP $$8 onoff_option egp_group",
"egp_group :",
"egp_group : '{' egp_group_stmts '}'",
"egp_group_stmts :",
"egp_group_stmts : egp_group_stmts egp_group_stmt L_EOS",
"egp_group_stmts : egp_group_stmts error L_EOS",
"egp_group_stmt : T_PREFERENCE preference",
"egp_group_stmt : T_DEFAULTMETRIC metric",
"egp_group_stmt : T_PKTSIZE number",
"egp_group_stmt : T_TRACEOPTIONS egp_trace_options",
"$$9 :",
"egp_group_stmt : T_GROUP $$9 egp_group_options '{' egp_peer_stmts '}'",
"egp_peer_stmts :",
"egp_peer_stmts : egp_peer_stmts egp_peer_stmt L_EOS",
"egp_peer_stmts : egp_peer_stmts error L_EOS",
"$$10 :",
"egp_peer_stmt : T_NEIGHBOR $$10 host egp_peer_options",
"egp_group_options :",
"egp_group_options : egp_group_options egp_group_option",
"egp_group_options : egp_group_options egp_peer_option",
"egp_group_option : T_PEERAS as",
"egp_group_option : T_LOCALAS as",
"egp_group_option : T_MAXUP L_NUMBER",
"egp_group_option : T_VERSION L_NUMBER",
"egp_group_option : T_PREFERENCE preference",
"egp_group_option : T_TRACEOPTIONS egp_trace_options",
"egp_peer_options :",
"egp_peer_options : egp_peer_options egp_peer_option",
"egp_peer_option : T_METRICOUT metric",
"egp_peer_option : T_NOGENDEFAULT",
"egp_peer_option : T_DEFAULTIN",
"egp_peer_option : T_DEFAULTOUT",
"egp_peer_option : T_GATEWAY gateway",
"egp_peer_option : T_LCLADDR interface_local",
"egp_peer_option : T_SOURCENET network",
"egp_peer_option : T_P1 time",
"egp_peer_option : T_P2 time",
"egp_trace_options : trace_options",
"egp_prop_init : T_EGP",
"$$11 :",
"bgp_statement : T_BGP $$11 onoff_option bgp_group",
"bgp_group :",
"bgp_group : '{' bgp_group_stmts '}'",
"bgp_group_stmts :",
"bgp_group_stmts : bgp_group_stmts bgp_group_stmt L_EOS",
"bgp_group_stmts : bgp_group_stmts error L_EOS",
"bgp_group_stmt : T_PREFERENCE preference",
"bgp_group_stmt : T_DEFAULTMETRIC metric",
"bgp_group_stmt : T_TRACEOPTIONS bgp_trace_options",
"$$12 :",
"$$13 :",
"bgp_group_stmt : T_GROUP T_TYPE bgp_linktype T_PEERAS as $$12 bgp_peer_options $$13 '{' bgp_peer_stmts '}'",
"bgp_peer_options :",
"bgp_peer_options : bgp_peer_options bgp_peer_option",
"bgp_peer_stmts :",
"bgp_peer_stmts : bgp_peer_stmts bgp_peer_stmt L_EOS",
"bgp_peer_stmts : bgp_peer_stmts error L_EOS",
"$$14 :",
"bgp_peer_stmt : T_NEIGHBOR $$14 host bgp_peer_options",
"$$15 :",
"bgp_peer_stmt : T_ALLOW $$15 '{' bgp_allow_list '}'",
"bgp_peer_option : T_METRICOUT metric",
"bgp_peer_option : T_LOCALAS as",
"bgp_peer_option : T_NOGENDEFAULT",
"bgp_peer_option : T_GATEWAY gateway",
"bgp_peer_option : T_PREFERENCE preference",
"bgp_peer_option : T_LCLADDR interface_local",
"bgp_peer_option : T_HOLDTIME time",
"bgp_peer_option : T_TRACEOPTIONS bgp_trace_options",
"bgp_peer_option : T_VERSION L_NUMBER",
"bgp_peer_option : T_PASSIVE",
"bgp_peer_option : T_DEFAULTIN",
"bgp_peer_option : T_DEFAULTOUT",
"bgp_peer_option : T_KEEPALL",
"bgp_peer_option : T_SENDBUF bgp_kbufsize",
"bgp_peer_option : T_RECVBUF bgp_kbufsize",
"bgp_peer_option : T_SPOOLBUF number",
"bgp_kbufsize : number",
"bgp_linktype : T_INTERNAL",
"bgp_linktype : T_EXTERNAL",
"bgp_linktype : T_IGP",
"bgp_linktype : T_TEST",
"bgp_trace_options : trace_options",
"bgp_prop_init : T_BGP",
"bgp_allow_list :",
"bgp_allow_list : bgp_allow_list bgp_allow L_EOS",
"bgp_allow_list : bgp_allow_list error L_EOS",
"bgp_allow : all_mask",
"bgp_allow : host_mask",
"bgp_allow : network_mask",
"$$16 :",
"redirect_statement : T_REDIRECT $$16 onoff_option redirect_group",
"redirect_group :",
"redirect_group : '{' redirect_group_stmts '}'",
"redirect_group_stmts :",
"redirect_group_stmts : redirect_group_stmts redirect_group_stmt L_EOS",
"redirect_group_stmts : redirect_group_stmts error L_EOS",
"redirect_group_stmt : T_PREFERENCE preference",
"redirect_group_stmt : T_INTERFACE interface_all_list redirect_interface_options",
"redirect_group_stmt : T_TRUSTEDGATEWAYS gateway_list",
"redirect_group_stmt : T_TRACEOPTIONS redirect_trace_options",
"redirect_interface_options : redirect_interface_option",
"redirect_interface_options : redirect_interface_options redirect_interface_option",
"redirect_interface_option : T_NOREDIRECTS",
"redirect_trace_options : trace_options",
"route_order :",
"$$17 :",
"route_statement : T_STATIC $$17 '{' route_stmts '}'",
"route_stmts : route_stmt L_EOS",
"route_stmts : route_stmts route_stmt L_EOS",
"route_stmts : error L_EOS",
"route_stmt : route_dest T_GATEWAY gateway_list interface_list_option preference_option rts_options",
"route_stmt : route_dest T_INTERFACE interface_all preference_option rts_options",
"route_dest : host_mask",
"route_dest : network_mask",
"route_dest : T_DEFAULT",
"rts_options :",
"rts_options : rts_options rts_option",
"rts_option : T_RETAIN",
"rts_option : T_REJECT",
"rts_option : T_BLACKHOLE",
"rts_option : T_NOINSTALL",
"control_order :",
"control_statement : T_IMPORT T_PROTO control_exterior T_AS as import_option L_EOS",
"control_statement : T_IMPORT T_PROTO T_BGP aspath_match import_option L_EOS",
"control_statement : T_IMPORT T_PROTO import_interior interface_gateway_list import_option L_EOS",
"control_statement : T_IMPORT T_PROTO T_OSPF_ASE tag_option import_option L_EOS",
"control_statement : T_EXPORT T_PROTO control_exterior T_AS as prop_source_option L_EOS",
"control_statement : T_EXPORT T_PROTO export_interior interface_gateway_list prop_source_option L_EOS",
"control_statement : T_EXPORT T_PROTO export_ospf_ase ospf_type_option tag_as_option prop_source_option L_EOS",
"control_exterior : proto_exterior",
"import_interior : proto_interior",
"import_option : T_RESTRICT",
"import_option : preference_option '{' import_list '}'",
"import_list :",
"import_list : import_list import_listen L_EOS",
"import_list : import_list error L_EOS",
"$$18 :",
"import_listen : $$18 dest_mask preference_restrict_option",
"export_interior : proto_interior",
"export_ospf_ase : T_OSPF_ASE",
"prop_source_option : T_RESTRICT",
"prop_source_option : metric_option '{' prop_source_list '}'",
"prop_source_list :",
"prop_source_list : prop_source_list prop_source L_EOS",
"prop_source_list : prop_source_list error L_EOS",
"prop_source : T_PROTO proto_exterior T_AS as prop_metric_option",
"prop_source : T_PROTO aspath_prop_init aspath_match prop_metric_option",
"prop_source : T_PROTO tag_prop_init T_TAG tag prop_metric_option",
"prop_source : T_PROTO prop_direct interface_list_option prop_metric_option",
"prop_source : T_PROTO prop_static interface_list_option prop_metric_option",
"prop_source : T_PROTO prop_kernel interface_list_option prop_metric_option",
"prop_source : T_PROTO prop_default prop_metric_option",
"prop_source : T_PROTO rip_prop_init interface_gateway_list prop_metric_option",
"prop_source : T_PROTO ospf_prop_init prop_metric_option",
"prop_source : T_PROTO ospf_ase_prop_init prop_metric_option",
"prop_direct : T_DIRECT",
"prop_static : T_STATIC",
"prop_kernel : T_KERNEL",
"prop_default : T_DEFAULT",
"prop_metric_option : T_RESTRICT",
"prop_metric_option : metric_option prop_restrict_list_option",
"prop_restrict_list_option :",
"prop_restrict_list_option : '{' prop_restrict_list '}'",
"prop_restrict_list :",
"prop_restrict_list : prop_restrict_list prop_restrict L_EOS",
"prop_restrict_list : prop_restrict_list error L_EOS",
"$$19 :",
"prop_restrict : $$19 dest_mask metric_restrict_option",
"addr : T_NOP",
"addr : in_addr",
"dest_mask : all_mask",
"dest_mask : default_mask",
"dest_mask : host_mask",
"dest_mask : network_mask",
"all_mask : T_ALL",
"default_mask : T_NOP1",
"default_mask : T_DEFAULT",
"mask : T_NOP",
"mask : in_addr",
"gateway_list : gateway",
"gateway_list : gateway_list gateway",
"gateway : host",
"host : host_name",
"host : addr",
"host_mask : T_HOST host",
"network : host_name",
"network : addr",
"network_mask : network",
"network_mask : network T_MASKLEN number",
"network_mask : network T_MASK mask",
"in_addr : L_NUMBER",
"in_addr : byte_string",
"host_name : L_HNAME",
"host_name : L_KEYWORD",
"host_name : string",
"proto_interior : T_REDIRECT",
"proto_interior : T_RIP",
"proto_exterior : T_NOP",
"proto_exterior : egp_prop_init",
"proto_exterior : bgp_prop_init",
"onoff_option : T_ON",
"onoff_option : T_OFF",
"metric : number",
"metric : T_INFINITY",
"metric_option :",
"metric_option : T_METRIC metric",
"metric_restrict_option : metric_option",
"metric_restrict_option : T_RESTRICT",
"preference_option :",
"preference_option : T_PREFERENCE preference",
"preference_restrict_option : preference_option",
"preference_restrict_option : T_RESTRICT",
"preference : L_NUMBER",
"string : L_STRING",
"number : L_NUMBER",
"number : byte_string",
"byte_string : L_HEXSTRING",
"byte_string : L_OCTETSTRING",
"time : L_NUMBER",
"time : L_NUMBER ':' L_NUMBER",
"time : L_NUMBER ':' L_NUMBER ':' L_NUMBER",
"port : L_NUMBER",
"port : L_KEYWORD",
"as : L_NUMBER",
"as_list : as",
"as_list : as_list as",
"as_list_option :",
"as_list_option : T_AS as_list",
"tag_as_option :",
"tag_as_option : T_TAG tag_as",
"tag_as : tag",
"tag_as : T_AS",
"tag_as : T_AS number",
"tag_option :",
"tag_option : T_TAG tag",
"tag : number",
"tag_prop_init : proto_exterior",
"tag_prop_init : rip_prop_init",
"tag_prop_init : ospf_prop_init",
"tag_prop_init : ospf_ase_prop_init",
"aspath_prop_init : proto_exterior",
"aspath_prop_init : rip_prop_init",
"aspath_prop_init : ospf_prop_init",
"aspath_prop_init : ospf_ase_prop_init",
"$$20 :",
"aspath_match : T_ASPATH $$20 aspath_regex T_ORIGIN aspath_origin",
"aspath_origin : T_ANY",
"aspath_origin : aspath_origin_list",
"aspath_origin_list : aspath_origins",
"aspath_origin_list : aspath_origin_list '|' aspath_origins",
"aspath_origins : T_IGP",
"aspath_origins : T_EGP",
"aspath_origins : T_INCOMPLETE",
"aspath_regex : aspath_sum",
"aspath_regex : aspath_sum '|' aspath_regex",
"aspath_sum : aspath_term",
"aspath_sum : aspath_term aspath_sum",
"aspath_term : aspath_symbol",
"aspath_term : aspath_symbol '*'",
"aspath_term : aspath_symbol '+'",
"aspath_term : aspath_symbol '?'",
"aspath_term : aspath_symbol '{' aspath_range '}'",
"aspath_symbol : as",
"aspath_symbol : '.'",
"aspath_symbol : '(' aspath_regex ')'",
"aspath_range : number",
"aspath_range : number ','",
"aspath_range : number ',' number",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 4463 "parser.y"

/*
 *	Log any parsing errors
 */
static void
yyerror(s)
const char *s;
{
    byte *cp;

    trace(TR_ALL, 0, NULL);
    tracef("parse: %s ",
	   parse_where());

    switch (yychar) {
    case L_HEXSTRING:
	tracef("%s at '",
	       s);
	for (cp = yylval.hex.ptr; (cp - yylval.hex.ptr) < yylval.hex.len; cp++) {
	    tracef("%02x", *cp);
	}
	tracef("'");
	break;

    case L_OCTETSTRING:
	tracef("%s at '",
	       s);
	for (cp = yylval.hex.ptr; (cp - yylval.hex.ptr) < yylval.hex.len; cp++) {
	    tracef("%s%u",
		   (cp == yylval.hex.ptr) ? "" : ".",
		   *cp);
	}
	tracef("'");
	break;

    case L_NUMBER:
	tracef("%s at '%d'",
	       s,
	       yylval.num);
	break;

    case L_EOS:
	tracef("%s at 'end-of-statement'",
	       s);
	break;

    case L_ERROR:
	tracef("%s",
	       parse_error);
	break;

#ifdef	YYEOF
    case YYEOF:
#else	/* YYEOF */
    case 0:
#endif	/* YYEOF */
	tracef("%s at 'end-of-file'",
		   s);
	break;

    default:
	if (!parse_keyword_lookup(yychar)) {
#if	YYDEBUG != 0
#ifdef	YYTRANSLATE
	    tracef("%s at '%s'",
		   s,
		   yytname[YYTRANSLATE(yychar)]);
#else	/* YYTRANSLATE */
	    tracef("%s at '%s'",
		   s,
		   yyname[yychar]);
#endif	/* YYTRANSLATE */
#else	/* YYDEBUG */
	    tracef("%s",
		   s);
#endif	/* YYDEBUG */
	    break;
	}
	tracef("%s at '%s' (%u) length %d",
	       s,
	       yylval.str.ptr,
	       yylval.str.type,
	       yylval.str.len);
	break;

    case L_STRING:
    case L_HNAME:
    case L_KEYWORD:
	tracef("%s at '%s' length %d",
	       s,
	       yylval.str.ptr,
	       yylval.str.len);
	break;

#ifdef	YYEMPTY
    case YYEMPTY:
	tracef("%s",
	       s);
	break;
#endif	/* YYEMPTY */
    }
    trace(TR_ALL, LOG_ERR, NULL);
    trace(TR_ALL, 0, NULL);
}



/*
 * ------------------------------------------------------------------------
 * 
 * 	GateD, Release 3
 * 
 * 	Copyright (c) 1990,1991,1992,1993 by Cornell University
 * 	    All rights reserved.
 * 
 * 	THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY
 * 	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
 * 	LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * 	AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * 	Royalty-free licenses to redistribute GateD Release
 * 	3 in whole or in part may be obtained by writing to:
 * 
 * 	    GateDaemon Project
 * 	    Information Technologies/Network Resources
 * 	    200 CCC, Garden Avenue
 * 	    Cornell University
 * 	    Ithaca, NY  14853-2601  USA
 * 
 * 	GateD is based on Kirton's EGP, UC Berkeley's routing
 * 	daemon	 (routed), and DCN's HELLO routing Protocol.
 * 	Development of GateD has been supported in part by the
 * 	National Science Foundation.
 * 
 * 	Please forward bug fixes, enhancements and questions to the
 * 	gated mailing list: gated-people@gated.cornell.edu.
 * 
 * 	Authors:
 * 
 * 		Jeffrey C Honig <jch@gated.cornell.edu>
 * 		Scott W Brim <swb@gated.cornell.edu>
 * 
 * ------------------------------------------------------------------------
 * 
 *       Portions of this software may fall under the following
 *       copyrights:
 * 
 * 	Copyright (c) 1988 Regents of the University of California.
 * 	All rights reserved.
 * 
 * 	Redistribution and use in source and binary forms are
 * 	permitted provided that the above copyright notice and
 * 	this paragraph are duplicated in all such forms and that
 * 	any documentation, advertising materials, and other
 * 	materials related to such distribution and use
 * 	acknowledge that the software was developed by the
 * 	University of California, Berkeley.  The name of the
 * 	University may not be used to endorse or promote
 * 	products derived from this software without specific
 * 	prior written permission.  THIS SOFTWARE IS PROVIDED
 * 	``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
 * 	INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * 	MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
#line 1811 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 13:
#line 329 "parser.y"
{
				yyerrok;
			}
break;
case 15:
#line 338 "parser.y"
{
#if	YYDEBUG != 0
			    if (yyvsp[-1].num == T_OFF) {
				yydebug = 0;
			    } else {
				yydebug = 1;
			    }
#endif	/* YYDEBUG */
			}
break;
case 16:
#line 348 "parser.y"
{
#if	YYDEBUG != 0
			    if (yyvsp[-1].num < 0 || yyvsp[-1].num > PS_MAX) {
				(void) sprintf(parse_error, "invalid yystate value: %d",
					       yyvsp[-1].num);
				PARSE_ERROR;
			    }
			    parse_state = yyvsp[-1].num;
#endif	/* YYDEBUG */
			}
break;
case 17:
#line 359 "parser.y"
{
#if	YYDEBUG != 0
			    task_quit(0);
#endif	/* YYDEBUG */
			}
break;
case 18:
#line 369 "parser.y"
{
			    if (!BIT_TEST(task_state, TASKS_TEST)) {
				if (yyvsp[-1].flag) {
				    if (trace_flags) {
					trace_flags = trace_flags_save = yyvsp[-1].flag;
					trace_display(trace_flags, TR_PARSE);
				    } else if (trace_opened) {
					trace_flags = trace_flags_save = yyvsp[-1].flag;
					trace_display(trace_flags, TR_PARSE);
				    }
				} else {
				    if (trace_flags) {
					trace_flags = trace_flags_save = yyvsp[-1].flag;
					trace_display(trace_flags, TR_PARSE);
					trace_off();
				    }
				}
			    }
			}
break;
case 19:
#line 389 "parser.y"
{
			    if (!BIT_TEST(task_state, TASKS_TEST)) {
				if (yyvsp[-2].str.len) {
				    int append = (int) yyvsp[-2].str.type;

				    if (trace_flags) {
					trace_flags_save = trace_flags;
					trace_off();
				    }
				    trace_on(yyvsp[-2].str.ptr, append);
				}
			    }
			}
break;
case 20:
#line 405 "parser.y"
{
			    yyval.str.len = 0;
			}
break;
case 21:
#line 409 "parser.y"
{
			    yyval.str = yyvsp[-1].str;
			    yyval.str.type = yyvsp[0].num;
			}
break;
case 23:
#line 417 "parser.y"
{
			    yyval.num = yyvsp[-1].num * 1024;
			}
break;
case 24:
#line 421 "parser.y"
{
			    yyval.num = yyvsp[-1].num * 1024 * 1024;
			}
break;
case 25:
#line 426 "parser.y"
{ yyval.num = TRUE; }
break;
case 26:
#line 427 "parser.y"
{ yyval.num = FALSE; }
break;
case 28:
#line 432 "parser.y"
{
			    if (parse_limit_check("file-size",
						  (u_int) yyvsp[-2].num,
						  TRACE_LIMIT_FILE_SIZE)) {
				PARSE_ERROR;
			    }
			    trace_limit_size = yyvsp[-2].num;

			    if (parse_limit_check("files",
						  (u_int) yyvsp[0].num,
						  TRACE_LIMIT_FILE_COUNT)) {
				PARSE_ERROR;
			    }
			    trace_limit_files = yyvsp[0].num;
			}
break;
case 29:
#line 451 "parser.y"
{
			    yyval.flag = (flag_t) 0;
			}
break;
case 30:
#line 455 "parser.y"
{
			    yyval.flag = yyval.flag;
			}
break;
case 32:
#line 463 "parser.y"
{
			    yyval.flag = yyvsp[-1].flag | yyvsp[0].flag;
			}
break;
case 33:
#line 467 "parser.y"
{
			    yyval.flag = yyvsp[-2].flag & ~yyvsp[0].flag;
			}
break;
case 36:
#line 479 "parser.y"
{
			    yyval.flag = (flag_t) 0;
			}
break;
case 39:
#line 487 "parser.y"
{
			    yyval.flag = yyvsp[-1].flag | yyvsp[0].flag;
			}
break;
case 40:
#line 495 "parser.y"
{
			    yyval.flag = TR_NOSTAMP;
			}
break;
case 41:
#line 499 "parser.y"
{
			    yyval.flag = TR_MARK;
			}
break;
case 42:
#line 503 "parser.y"
{
			    yyval.flag = TR_PARSE;
			}
break;
case 43:
#line 507 "parser.y"
{
#ifdef	TR_ADV
			    yyval.flag = TR_ADV;
#else	/* TR_ADV */
			    yyval.flag = 0;
#endif	/* TR_ADV */
			}
break;
case 44:
#line 518 "parser.y"
{
			    yyval.flag = TR_ALL;
			}
break;
case 45:
#line 522 "parser.y"
{
			    yyval.flag = TR_INT|TR_EXT|TR_RT;
			}
break;
case 46:
#line 526 "parser.y"
{
			    yyval.flag = TR_INT;
			}
break;
case 47:
#line 530 "parser.y"
{
			    yyval.flag = TR_EXT;
			}
break;
case 48:
#line 534 "parser.y"
{
			    yyval.flag = TR_RT;
			}
break;
case 49:
#line 538 "parser.y"
{
			    yyval.flag = TR_UPDATE;
			}
break;
case 50:
#line 542 "parser.y"
{
			    yyval.flag = TR_TASK;
			}
break;
case 51:
#line 546 "parser.y"
{
			    yyval.flag = TR_TIMER;
			}
break;
case 52:
#line 550 "parser.y"
{
			    yyval.flag = TR_PROTOCOL;
			}
break;
case 53:
#line 554 "parser.y"
{
			    yyval.flag = TR_KRT;
			}
break;
case 54:
#line 558 "parser.y"
{
			    yyval.flag = TR_BGP;
			}
break;
case 55:
#line 562 "parser.y"
{
			    yyval.flag = TR_EGP;
			}
break;
case 56:
#line 566 "parser.y"
{
			    yyval.flag = TR_ICMP;
			}
break;
case 57:
#line 570 "parser.y"
{
			    yyval.flag = TR_OSPF;
			}
break;
case 58:
#line 574 "parser.y"
{
			    yyval.flag = TR_RIP;
			}
break;
case 59:
#line 582 "parser.y"
{
				if (parse_new_state(PS_DEFINE)) {
					PARSE_ERROR;
				}
			}
break;
case 60:
#line 591 "parser.y"
{
			    parse_contig_masks = FALSE;
			}
break;
case 61:
#line 595 "parser.y"
{
			    parse_contig_masks = TRUE;
			    if (parse_adv_append(&martian_list, yyvsp[-2].adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 62:
#line 602 "parser.y"
{
			    if (inet_autonomous_system != yyvsp[-1].as) {
				if (inet_autonomous_system) {
				    inet_as_unlink(inet_autonomous_system);
				}
				inet_autonomous_system = yyvsp[-1].as;
				inet_as_link(inet_autonomous_system);
			    }
			}
break;
case 63:
#line 612 "parser.y"
{
			    if (inet_parse_routerid(yyvsp[-1].sockaddr, parse_error)) {
				PARSE_ERROR;
			    }
			}
break;
case 64:
#line 621 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 65:
#line 625 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_DM | yyvsp[-1].flag, (proto_t) 0);
			    yyval.adv->adv_dm = yyvsp[-2].dm;
			    yyval.adv = parse_adv_dm_append(yyvsp[-3].adv, yyval.adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			}
break;
case 66:
#line 634 "parser.y"
{
			    yyerrok;
			}
break;
case 67:
#line 640 "parser.y"
{
			    yyval.flag = ADVF_NO;
			}
break;
case 68:
#line 644 "parser.y"
{
			    yyval.flag = ADVF_NO;
			}
break;
case 72:
#line 657 "parser.y"
{
				if (parse_new_state(PS_OPTIONS)) {
					PARSE_ERROR;
				}
			}
break;
case 76:
#line 674 "parser.y"
{
			    krt_install = FALSE;
			}
break;
case 77:
#line 678 "parser.y"
{
			    rt_default_needed = TRUE;
			    if (PARSE_METRIC_ISSET(&yyvsp[-1].metric)) {
				rt_default_rtparms.rtp_preference = yyvsp[-1].metric.metric;
			    }
			    rt_default_rtparms.rtp_router = yyvsp[0].sockaddr;
			}
break;
case 78:
#line 686 "parser.y"
{
			    task_newstate(TASKS_NOSEND, 0);
			}
break;
case 79:
#line 690 "parser.y"
{
			    task_newstate(TASKS_NORESOLV, 0);
			}
break;
case 80:
#line 694 "parser.y"
{
#ifdef	LOG_DAEMON
			    (void) setlogmask(yyvsp[0].num);
#else	/* LOG_DAEMON */
			    (void) sprintf(parse_error, "system does not support setlogmask()");
			    PARSE_ERROR;
#endif	/* LOG_DAEMON */
			}
break;
case 81:
#line 707 "parser.y"
{
			    yyval.sockaddr = (sockaddr_un *) 0;
			}
break;
case 82:
#line 711 "parser.y"
{
			    parse_gwlist = &parse_gwp;
			}
break;
case 83:
#line 715 "parser.y"
{
			    yyval.sockaddr = sockdup(yyvsp[0].gwp->gw_addr);
			    gw_freelist(*parse_gwlist);
			    *parse_gwlist = parse_gwp = (gw_entry *) 0;
			}
break;
case 84:
#line 723 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num = LOG_MASK(yyvsp[0].num);
#endif	/* LOG_DAEMON */
			}
break;
case 85:
#line 729 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num = LOG_UPTO(yyvsp[0].num);
#endif	/* LOG_DAEMON */
			}
break;
case 86:
#line 735 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num = yyvsp[-1].num | LOG_MASK(yyvsp[0].num);
#endif	/* LOG_DAEMON */
			}
break;
case 87:
#line 743 "parser.y"
{
			    yyval.num = LOG_EMERG;
			}
break;
case 88:
#line 747 "parser.y"
{
			    yyval.num = LOG_ALERT;
			}
break;
case 89:
#line 751 "parser.y"
{
			    yyval.num = LOG_CRIT;
			}
break;
case 90:
#line 755 "parser.y"
{
			    yyval.num = LOG_ERR;
			}
break;
case 91:
#line 759 "parser.y"
{
			    yyval.num = LOG_WARNING;
			}
break;
case 92:
#line 763 "parser.y"
{
			    yyval.num = LOG_NOTICE;
			}
break;
case 93:
#line 767 "parser.y"
{
			    yyval.num = LOG_INFO;
			}
break;
case 94:
#line 771 "parser.y"
{
			    yyval.num = LOG_EMERG;
			}
break;
case 95:
#line 779 "parser.y"
{
			    if (parse_new_state(PS_INTERFACE)) {
				PARSE_ERROR;
			    }
			}
break;
case 96:
#line 788 "parser.y"
{
			    PROTO_SEEN(RTPROTO_DIRECT);
			}
break;
case 100:
#line 798 "parser.y"
{
			    yyerrok;
			}
break;
case 102:
#line 806 "parser.y"
{
			    config_list *list = config_list_alloc(yyvsp[0].config, 0);

			    parse_adv_propagate_config(yyvsp[-1].adv, list, (proto_t) 0);

			    if (parse_adv_append(&int_policy, yyvsp[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }

			    config_list_free(list);
			}
break;
case 103:
#line 818 "parser.y"
{
			    bzero((caddr_t) &parse_ifi, sizeof (parse_ifi));

			    parse_ifi.ifi_addr = yyvsp[0].sockaddr;
			}
break;
case 104:
#line 824 "parser.y"
{
			    if (if_parse_add(&parse_ifi, parse_error)) {
				PARSE_ERROR;
			    }
			}
break;
case 107:
#line 838 "parser.y"
{
			    task_newstate(TASKS_STRICTIFS, 0);
			}
break;
case 108:
#line 842 "parser.y"
{
			    if (parse_limit_check("scan-interval",
						  (u_int) yyvsp[0].time,
						  KRT_LIMIT_SCANTIMER)) {
				PARSE_ERROR;
			    }
			    
			    timer_set(krt_task->task_timer[KRT_TIMER_IFCHECK],
				      yyvsp[0].time,
				      (time_t) 0);
			}
break;
case 109:
#line 857 "parser.y"
{
			    parse_ifi.ifi_addr_broadcast = yyvsp[0].sockaddr;
			    BIT_SET(parse_ifi.ifi_state, IFS_BROADCAST);
			}
break;
case 110:
#line 862 "parser.y"
{
			    parse_ifi.ifi_addr_local = yyvsp[0].sockaddr;
			    BIT_SET(parse_ifi.ifi_state, IFS_POINTOPOINT);
			}
break;
case 111:
#line 867 "parser.y"
{
			}
break;
case 114:
#line 878 "parser.y"
{
			    parse_ifi.ifi_subnetmask = yyvsp[0].sockaddr;
			}
break;
case 115:
#line 882 "parser.y"
{
			    BIT_SET(parse_ifi.ifi_state, IFS_MULTICAST);
			}
break;
case 117:
#line 890 "parser.y"
{
			    yyval.config = config_append(yyvsp[-1].config, yyvsp[0].config);
			    if (!yyval.config) {
				PARSE_ERROR;
			    }
			}
break;
case 118:
#line 900 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_PREFERENCE_UP, (void_t) yyvsp[0].pref);
			}
break;
case 119:
#line 904 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_PREFERENCE_DOWN, (void_t) yyvsp[0].pref);
			}
break;
case 120:
#line 908 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_PASSIVE, (void_t) TRUE);
			}
break;
case 121:
#line 912 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_SIMPLEX, (void_t) TRUE);
			}
break;
case 122:
#line 916 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_REJECT, (void_t) TRUE);
			}
break;
case 123:
#line 920 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_BLACKHOLE, (void_t) TRUE);
			}
break;
case 124:
#line 927 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ANY|ADVF_FIRST, (proto_t) 0);
			}
break;
case 125:
#line 931 "parser.y"
{
			    yyval.adv = yyvsp[0].adv;
			}
break;
case 127:
#line 939 "parser.y"
{
			    yyval.adv = yyvsp[0].adv;
			}
break;
case 128:
#line 946 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ANY|ADVF_FIRST, (proto_t) 0);
			}
break;
case 130:
#line 954 "parser.y"
{
			    BIT_SET(yyvsp[0].adv->adv_flag, ADVF_FIRST);
			    yyval.adv = yyvsp[0].adv;
			}
break;
case 131:
#line 959 "parser.y"
{
			    yyval.adv = yyvsp[-1].adv;
			    if (parse_adv_append(&yyval.adv, yyvsp[0].adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 132:
#line 968 "parser.y"
{
			    switch (yyvsp[0].adv->adv_flag & ADVF_TYPE) {

			    case ADVFT_IFN:
				trace(TR_PARSE, 0, "parse: %s INTERFACE: %A*",
				      parse_where(),
				      yyval.adv->adv_ifn->ifae_addr);
				break;
				
			    case ADVFT_IFAE:
				trace(TR_PARSE, 0, "parse: %s INTERFACE: %A",
				      parse_where(),
				      yyval.adv->adv_ifae->ifae_addr);
			    }
			}
break;
case 133:
#line 987 "parser.y"
{
			    int valid_ifname = 0;

			    switch (yyvsp[0].str.type) {
			    case L_KEYWORD:
			    case L_STRING:
				if (yyvsp[0].str.len < IFNAMSIZ) {
				    valid_ifname++;
				}
				break;

			    default:
				break;
			    }

			    if (valid_ifname) {
				/* First try to look up as an interface name */

				yyval.adv = if_parse_name(yyvsp[0].str.ptr, FALSE);
			    } else {
				/* Doesn't meet the criteria to be a name */

				yyval.adv = (adv_entry *) 0;
			    }
			    
			    if (!yyval.adv && !BIT_TEST(task_state, TASKS_NORESOLV)) {
				/* Try to resolve as a host name */

				sockaddr_un *addr = parse_addr_hostname(yyvsp[0].str.ptr);

				if (addr) {
				    yyval.adv = if_parse_address(addr);
				}

			    }

			    if (!yyval.adv) {
				if (valid_ifname && !BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    /* Assume it is a reference to an interface that does not exist */

				    yyval.adv = if_parse_name(yyvsp[0].str.ptr, TRUE);
				} else {
				    /* Time to give up */
				    
				    (void) sprintf(parse_error, "Interface not found at '%s'",
						   yyvsp[0].str.ptr);
				    PARSE_ERROR;
				}
			    }
				
			    free_charstr(&yyvsp[0].str);
			}
break;
case 134:
#line 1040 "parser.y"
{
			    yyval.adv = if_parse_address(yyvsp[0].sockaddr);
			    if (!yyval.adv) {
				(void) sprintf(parse_error, "Interface not found at '%A'",
					       yyvsp[0].sockaddr);
				PARSE_ERROR;
			    }

			    sockfree(yyvsp[0].sockaddr);
			}
break;
case 135:
#line 1053 "parser.y"
{
			    if_addr *ifap;
			    
			    ifap = if_withlcladdr(yyvsp[0].sockaddr, FALSE);
			    if (ifap) {
				yyval.ifae = ifae_alloc(ifap->ifa_addrent_local);
			    } else {
				if (BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    (void) sprintf(parse_error, "Invalid interface at '%A'",
						   yyvsp[0].sockaddr);
				    PARSE_ERROR;
				} else {
				    yyval.ifae = ifae_locate(yyvsp[0].sockaddr, &if_local_list);
				}
			    }
			    sockfree(yyvsp[0].sockaddr);
			    trace(TR_PARSE, 0, "parse: %s LOCAL ADDRESS: %A",
				  parse_where(),
				  yyval.ifae->ifae_addr);
			}
break;
case 137:
#line 1077 "parser.y"
{
			    sockaddr_un *addr;

			    if (BIT_TEST(task_state, TASKS_NORESOLV)
				|| !(addr = parse_addr_hostname(yyvsp[0].str.ptr))) {
				PARSE_ERROR;
			    }
			    yyval.sockaddr = sockdup(addr);
			    free_charstr(&yyvsp[0].str);
			}
break;
case 138:
#line 1092 "parser.y"
{
			    if (parse_new_state(PS_PROTO)) {
				PARSE_ERROR;
			    }
			}
break;
case 144:
#line 1110 "parser.y"
{
			    PROTO_SEEN(RTPROTO_RIP);

			    parse_gwlist = &rip_gw_list;

			    rip_trace_flags = trace_flags;
			}
break;
case 145:
#line 1118 "parser.y"
{
			    switch (yyvsp[-1].num) {
			    case T_OFF:
				BIT_RESET(rip_flags, RIPF_ON);
				break;

			    case T_ON:
				BIT_SET(rip_flags, RIPF_ON);
				break;
			    }
			}
break;
case 150:
#line 1138 "parser.y"
{
			    yyerrok;
			}
break;
case 151:
#line 1144 "parser.y"
{
			    rip_preference = yyvsp[0].pref;
			}
break;
case 152:
#line 1148 "parser.y"
{
			    if (parse_metric_check(RTPROTO_RIP, &yyvsp[0].metric)) {
				PARSE_ERROR;
			    }
			    rip_default_metric = yyvsp[0].metric.metric;
			}
break;
case 153:
#line 1155 "parser.y"
{
			    BIT_RESET(rip_flags, RIPF_CHOOSE);
			    BIT_SET(rip_flags, RIPF_BROADCAST);
			}
break;
case 154:
#line 1160 "parser.y"
{
			    BIT_RESET(rip_flags, RIPF_CHOOSE|RIPF_BROADCAST);
			}
break;
case 155:
#line 1164 "parser.y"
{
			    rip_trace_flags =  yyvsp[0].flag;
			}
break;
case 156:
#line 1168 "parser.y"
{
			    BIT_SET(rip_flags, RIPF_NOCHECK);
			}
break;
case 157:
#line 1172 "parser.y"
{
			    config_list *list = config_list_alloc(yyvsp[0].config, rip_config_free);

			    parse_adv_propagate_config(yyvsp[-1].adv, list, RTPROTO_RIP);

			    if (parse_adv_append(&rip_int_policy, yyvsp[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }

			    config_list_free(list);
			}
break;
case 158:
#line 1184 "parser.y"
{
			    rip_n_trusted += parse_gw_flag(yyvsp[0].adv, RTPROTO_RIP, GWF_TRUSTED);
			    if (!rip_n_trusted) {
				PARSE_ERROR;
			    }
			}
break;
case 159:
#line 1191 "parser.y"
{
			    rip_n_source += parse_gw_flag(yyvsp[0].adv, RTPROTO_RIP, GWF_SOURCE);
			    if (!rip_n_source) {
				PARSE_ERROR;
			    }
			    BIT_SET(rip_flags, RIPF_SOURCE);
			}
break;
case 161:
#line 1203 "parser.y"
{
			    yyval.config = config_append(yyvsp[-1].config, yyvsp[0].config);
			    if (!yyval.config) {
				PARSE_ERROR;
			    }
			}
break;
case 162:
#line 1213 "parser.y"
{
			    yyval.config = config_alloc(RIP_CONFIG_NOIN, (void_t) TRUE);
			}
break;
case 163:
#line 1217 "parser.y"
{
			    yyval.config = config_alloc(RIP_CONFIG_NOOUT, (void_t) TRUE);
			}
break;
case 164:
#line 1221 "parser.y"
{
			    if (parse_metric_check(RTPROTO_RIP, &yyvsp[0].metric)) {
				PARSE_ERROR;
			    }
			    yyval.config = config_alloc(RIP_CONFIG_METRICIN, (void_t) yyvsp[0].metric.metric);
			}
break;
case 165:
#line 1228 "parser.y"
{
			    if (parse_metric_check(RTPROTO_RIP, &yyvsp[0].metric)) {
				PARSE_ERROR;
			    }
			    yyval.config = config_alloc(RIP_CONFIG_METRICOUT, (void_t) yyvsp[0].metric.metric);
			}
break;
case 166:
#line 1235 "parser.y"
{
			    yyval.config = config_alloc(RIP_CONFIG_AUTH, yyvsp[0].vt);
			}
break;
case 167:
#line 1239 "parser.y"
{
			    flag_t flag;
			    
			    switch (yyvsp[-1].num) {
			    case 1:
				if (yyvsp[0].flag) {
				    (void) sprintf(parse_error, "options not valid with version 1");
				    PARSE_ERROR;
				}
				flag = RIP_IFPS_V1;
				break;

			    case 2:
				if (yyvsp[0].flag) {
				    flag = yyvsp[0].flag;
				} else {
				    /* This means whatever options the interface is capable of */
#ifdef	IP_MULTICAST
				    flag = RIP_IFPS_V2;
#else	/* IP_MULTICAST */
				    flag = RIP_IFPS_V2BC;
#endif	/* IP_MULTICAST */
				}
				break;

			    default:
				(void) sprintf(parse_error, "invalid version");
				PARSE_ERROR;
			    }
			    yyval.config = config_alloc(RIP_CONFIG_FLAG, (void_t) flag);
			}
break;
case 168:
#line 1273 "parser.y"
{
			    yyval.flag = 0;
			}
break;
case 169:
#line 1277 "parser.y"
{
			    yyval.flag = RIP_IFPS_V2MC;
			}
break;
case 170:
#line 1281 "parser.y"
{
			    yyval.flag = RIP_IFPS_V2BC;
			}
break;
case 171:
#line 1287 "parser.y"
{
			    yyval.vt = (void_t) 0;
			}
break;
case 172:
#line 1291 "parser.y"
{
			    struct authinfo *ap = (struct authinfo *) task_block_alloc(rip_auth_block_index);

			    if (yyvsp[0].str.len > RIP_AUTH_SIZE) {
				sprintf(parse_error, "authentication-key \"%s\"%d longer than %d characters",
					yyvsp[0].str.ptr,
					yyvsp[0].str.len,
					RIP_AUTH_SIZE);
				PARSE_ERROR;
			    }

			    ap->auth_family = RIP_AF_AUTH;
			    ap->auth_type = RIP_AUTH_SIMPLE;
			    /* Left justify the authentication key */
			    (void) strncpy((caddr_t) ap->auth_data, yyvsp[0].str.ptr, RIP_AUTH_SIZE);

			    free_charstr(&yyvsp[0].str);

			    yyval.vt = (void_t) ap;
			}
break;
case 174:
#line 1319 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_RIP;
			    parse_gwlist = &rip_gw_list;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 175:
#line 1337 "parser.y"
{
			    PROTO_SEEN(RTPROTO_OSPF);

			    parse_gwlist = &ospf.gw_list;

			    ospf.trace_flags = trace_flags;

			    /* Somewhere around here is where we will figure out which OSPF global structure we are */
			    /* refering to and initialize it once we support multiple instantations of OSPF that is. */
			}
break;
case 176:
#line 1348 "parser.y"
{
			    if (yyvsp[-1].num == T_OFF) {
				ospf.ospf_admin_stat = OSPF_DISABLED;
			    } else {
				if (ospf_parse_valid_check(parse_error)) {
				    PARSE_ERROR;
				}
				ospf.ospf_admin_stat = OSPF_ENABLED;
			    }
			}
break;
case 181:
#line 1367 "parser.y"
{
				yyerrok;
			}
break;
case 182:
#line 1373 "parser.y"
{
			}
break;
case 183:
#line 1376 "parser.y"
{
			    ospf.trace_flags = yyvsp[0].flag;
			}
break;
case 184:
#line 1380 "parser.y"
{
			    ospf.export_interval = yyvsp[0].time;
			}
break;
case 185:
#line 1384 "parser.y"
{
			    ospf.export_limit = yyvsp[0].num;
			}
break;
case 186:
#line 1388 "parser.y"
{
			    ospf.mon_authtype = OSPF_AUTH_SIMPLE;
			    bcopy((caddr_t) yyvsp[0].hex.ptr, (caddr_t) ospf.mon_authkey, OSPF_AUTH_SIZE);

			    free_bytestr(&yyvsp[0].hex);
			}
break;
case 187:
#line 1395 "parser.y"
{
			    ospf.log_first = yyvsp[-1].u_num;
			    ospf.log_every = yyvsp[0].u_num;
			}
break;
case 188:
#line 1400 "parser.y"
{
			    ospf_AREA = ospf_parse_area_alloc(yyvsp[0].u_num, parse_error);
			    if (!ospf_AREA) {
				PARSE_ERROR;
			    }
			    ospf_AREA->authtype = OSPF_AUTH_NONE;		/* Default to no authentication */
			}
break;
case 189:
#line 1408 "parser.y"
{
			    if (ospf_parse_area_check(ospf_AREA, parse_error)) {
				PARSE_ERROR;
			    }
			}
break;
case 190:
#line 1417 "parser.y"
{
			    yyval.u_num = OSPF_LOG_FIRST;
			}
break;
case 191:
#line 1421 "parser.y"
{
			    if (parse_limit_check("syslog first",
						  (u_int) yyvsp[0].num,
						  OSPF_LIMIT_LOG_FIRST)) {
				PARSE_ERROR;
			    }
			    yyval.u_num = yyvsp[0].num;
			}
break;
case 192:
#line 1433 "parser.y"
{
			    yyval.u_num = OSPF_LOG_EVERY;
			}
break;
case 193:
#line 1437 "parser.y"
{
			    if (parse_limit_check("syslog every",
						  (u_int) yyvsp[0].num,
						  OSPF_LIMIT_LOG_EVERY)) {
				PARSE_ERROR;
			    }
			    yyval.u_num = yyvsp[0].num;
			}
break;
case 196:
#line 1450 "parser.y"
{
			    yyerrok;
			}
break;
case 197:
#line 1456 "parser.y"
{
			    ospf.preference_ase = yyvsp[0].pref;
			}
break;
case 198:
#line 1460 "parser.y"
{
			    ospf.export_metric = yyvsp[0].metric.metric;
			}
break;
case 199:
#line 1464 "parser.y"
{
			    switch (yyvsp[0].metric.state) {
			    case PARSE_METRICS_SET:
				ospf.export_tag = yyvsp[0].metric.metric;
				break;

			    case PARSE_METRICS_ALTERNATE:
				ospf.export_tag = PATH_OSPF_TAG_TRUSTED |
				    ((yyvsp[0].metric.metric << PATH_OSPF_TAG_USR_SHIFT) & PATH_OSPF_TAG_USR_MASK);
				break;
			    }
			}
break;
case 200:
#line 1477 "parser.y"
{
			    ospf.export_type = yyvsp[0].metric.metric;
			}
break;
case 203:
#line 1485 "parser.y"
{
			    yyerrok;
			}
break;
case 204:
#line 1491 "parser.y"
{
			    ospf_AREA->authtype = yyvsp[0].num;
			}
break;
case 205:
#line 1495 "parser.y"
{
			    if (ospf_AREA->area_id == OSPF_BACKBONE) {
				(void) sprintf(parse_error, "stub option not valid for backbone");
				PARSE_ERROR;
			    }

			    /* This is a stub */
			    BIT_SET(ospf_AREA->area_flags, OSPF_AREAF_STUB);

			    /* And we inject a default */
			    if (PARSE_METRIC_ISSET(&yyvsp[0].metric)) {
				BIT_SET(ospf_AREA->area_flags, OSPF_AREAF_STUB_DEFAULT);
				ospf_AREA->dflt_metric = yyvsp[0].metric.metric;
			    }
			}
break;
case 206:
#line 1510 "parser.y"
{}
break;
case 207:
#line 1512 "parser.y"
{
			    adv_entry *adv;

			    if (ospf_AREA->nrcnt) {
				(void) sprintf(parse_error, "net range already specified");
				PARSE_ERROR;
			    }

			    /* Install each of the entries */
			    ADV_LIST(yyvsp[-1].adv, adv) {
				ospf_parse_add_net(ospf_AREA,
						   adv->adv_dm.dm_dest,
						   adv->adv_dm.dm_mask);
			    } ADV_LIST_END(yyvsp[-1].adv, adv) ;

			    adv_free_list(yyvsp[-1].adv);
			}
break;
case 208:
#line 1530 "parser.y"
{
			    if (parse_adv_append(&ospf_AREA->intf_policy, yyvsp[0].adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 209:
#line 1536 "parser.y"
{
			    struct INTF *vif;

			    vif = ospf_parse_virt_parse(ospf_AREA, yyvsp[-3].sockaddr, yyvsp[-1].u_num, yyvsp[0].conflist, parse_error);
			    if (!vif) {
				PARSE_ERROR;
			    }

			    config_list_free(yyvsp[0].conflist);
			}
break;
case 210:
#line 1550 "parser.y"
{
			    config_list *list = yyvsp[0].conflist;

			    if (PARSE_METRIC_ISSET(&yyvsp[-1].metric)) {

				list = config_list_add(list,
						       config_alloc(OSPF_CONFIG_COST,
								    (void_t) yyvsp[-1].metric.metric),
						       ospf_config_free);
				if (!list) {
				    PARSE_ERROR;
				}
			    }

			    parse_adv_propagate_config(yyvsp[-2].adv, list, RTPROTO_OSPF);

			    config_list_free(list);

			    yyval.adv = yyvsp[-2].adv;
			}
break;
case 211:
#line 1571 "parser.y"
{
			    config_list *list = yyvsp[0].conflist;

			    list = config_list_add(list,
						   config_alloc(OSPF_CONFIG_TYPE,
								(void_t) NONBROADCAST),
						   ospf_config_free);
			    if (!list) {
				PARSE_ERROR;
			    }
			    
			    if (PARSE_METRIC_ISSET(&yyvsp[-1].metric)) {

				list = config_list_add(list,
						       config_alloc(OSPF_CONFIG_COST,
								    (void_t) yyvsp[-1].metric.metric),
						       ospf_config_free);
				if (!list) {
				    PARSE_ERROR;
				}
			    }

			    parse_adv_propagate_config(yyvsp[-3].adv, list, RTPROTO_OSPF);

			    config_list_free(list);

			    yyval.adv = yyvsp[-3].adv;
			}
break;
case 212:
#line 1602 "parser.y"
{
			    yyval.conflist = (config_list *) 0;
			}
break;
case 213:
#line 1606 "parser.y"
{
			    yyval.conflist = config_list_alloc(yyvsp[-1].config, ospf_config_free);
			}
break;
case 215:
#line 1614 "parser.y"
{
			    yyval.config = config_append(yyvsp[-2].config, yyvsp[-1].config);
			    if (!yyval.config) {
				PARSE_ERROR;
			    }
			}
break;
case 216:
#line 1621 "parser.y"
{
				yyerrok;
			}
break;
case 217:
#line 1628 "parser.y"
{
			    yyval.conflist = (config_list *) 0;
			}
break;
case 218:
#line 1632 "parser.y"
{
			    yyval.conflist = config_list_alloc(yyvsp[-1].config, ospf_config_free);
			}
break;
case 220:
#line 1640 "parser.y"
{
			    yyval.config = config_append(yyvsp[-2].config, yyvsp[-1].config);
			    if (!yyval.config) {
				PARSE_ERROR;
			    }
			}
break;
case 221:
#line 1647 "parser.y"
{
				yyerrok;
			}
break;
case 222:
#line 1654 "parser.y"
{
			    yyval.config = config_alloc(OSPF_CONFIG_ENABLE, (void_t) TRUE);
			}
break;
case 223:
#line 1658 "parser.y"
{
			    yyval.config = config_alloc(OSPF_CONFIG_ENABLE, (void_t) FALSE);
			}
break;
case 224:
#line 1662 "parser.y"
{
			    if (parse_limit_check("retransmit-interval",
						  (u_int) yyvsp[0].time,
						  OSPF_LIMIT_RETRANSMITINTERVAL)) {
				PARSE_ERROR;
			    }
			    yyval.config = config_alloc(OSPF_CONFIG_RETRANSMIT, (void_t) yyvsp[0].time);
			}
break;
case 225:
#line 1671 "parser.y"
{
			    if (parse_limit_check("transit-delay",
						  (u_int) yyvsp[0].time,
						  OSPF_LIMIT_TRANSITDELAY)) {
				PARSE_ERROR;
			    }
			    yyval.config = config_alloc(OSPF_CONFIG_TRANSIT, (void_t) yyvsp[0].time);
			}
break;
case 226:
#line 1680 "parser.y"
{
			    yyval.config = config_alloc(OSPF_CONFIG_PRIORITY, (void_t) yyvsp[0].num);
			}
break;
case 227:
#line 1684 "parser.y"
{
			    if (parse_limit_check("hello-interval",
						  (u_int) yyvsp[0].time,
						  OSPF_LIMIT_HELLOINTERVAL)) {
				PARSE_ERROR;
			    }
			    yyval.config = config_alloc(OSPF_CONFIG_HELLO, (void_t) yyvsp[0].time);
			}
break;
case 228:
#line 1693 "parser.y"
{
			    if (parse_limit_check("router-dead-interval",
						  (u_int) yyvsp[0].time,
						  OSPF_LIMIT_ROUTERDEADINTERVAL)) {
				PARSE_ERROR;
			    }
			    yyval.config = config_alloc(OSPF_CONFIG_ROUTERDEAD, (void_t) yyvsp[0].time);
			}
break;
case 229:
#line 1702 "parser.y"
{
			    /* Side-effect: The authentication type must be specified first */

			    switch (ospf_AREA->authtype) {
			    case OSPF_AUTH_NONE:
				sprintf(parse_error, "authentication-key specified when authentication-type is none");
				PARSE_ERROR;
				/* break; */

			    case OSPF_AUTH_SIMPLE:
				/* Simple password */
				break;

			    default:
				sprintf(parse_error, "unknown authentication type: %d",
					ospf_AREA->authtype);
				PARSE_ERROR;
			    }

			    yyval.config = config_alloc(OSPF_CONFIG_AUTHKEY,
					      (void_t) sockdup(sockbuild_byte(yyvsp[0].hex.ptr, yyvsp[0].hex.len)));

			    free_bytestr(&yyvsp[0].hex);
			}
break;
case 231:
#line 1731 "parser.y"
{
			    if (parse_limit_check("poll-interval",
						  (u_int) yyvsp[0].time,
						  OSPF_LIMIT_POLLINTERVAL)) {
				PARSE_ERROR;
			    }
			    yyval.config = config_alloc(OSPF_CONFIG_POLL, (void_t) yyvsp[0].time);
			}
break;
case 232:
#line 1740 "parser.y"
{
			    yyval.config = config_alloc(OSPF_CONFIG_ROUTERS, (void_t) yyvsp[-1].ospf_router);
			}
break;
case 233:
#line 1747 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			}
break;
case 234:
#line 1751 "parser.y"
{
				yyval.metric = yyvsp[0].metric;
			}
break;
case 235:
#line 1757 "parser.y"
{
			    yyval.metric = yyvsp[0].metric;
			    if (parse_metric_check(RTPROTO_OSPF, &yyval.metric)) {
				PARSE_ERROR;
			    }
			}
break;
case 236:
#line 1767 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			}
break;
case 237:
#line 1771 "parser.y"
{
			    yyval.metric = yyvsp[0].metric;
			}
break;
case 238:
#line 1777 "parser.y"
{
			    if (parse_limit_check("export-type",
						  (u_int) yyvsp[0].num,
						  OSPF_LIMIT_EXPORTTYPE)) {
				PARSE_ERROR;
			    }
			    PARSE_METRIC_SET(&yyval.metric, yyvsp[0].num);
			}
break;
case 239:
#line 1789 "parser.y"
{
			    yyval.u_num = yyvsp[0].u_num;
			}
break;
case 240:
#line 1793 "parser.y"
{
			    yyval.u_num = OSPF_BACKBONE;
			}
break;
case 241:
#line 1799 "parser.y"
{
			    if (parse_limit_check("area-number",
						  (u_int) yyvsp[0].num,
						  OSPF_LIMIT_AREA)) {
				PARSE_ERROR;
			    }
			    yyval.u_num = htonl(yyvsp[0].num);
			}
break;
case 242:
#line 1810 "parser.y"
{
			    if (parse_limit_check("authentication-type",
						  (u_int) yyvsp[0].num,
						  OSPF_LIMIT_AUTHTYPE)) {
				PARSE_ERROR;
			    }
			    yyval.num = yyvsp[0].num;
			}
break;
case 243:
#line 1819 "parser.y"
{
			    yyval.num = OSPF_AUTH_NONE;
			}
break;
case 244:
#line 1823 "parser.y"
{
			    yyval.num = OSPF_AUTH_SIMPLE;
			}
break;
case 245:
#line 1829 "parser.y"
{
			    if (yyvsp[0].str.len > OSPF_AUTH_SIZE) {
				sprintf(parse_error, "authentication-key \"%s\"%d longer than %d characters",
					yyvsp[0].str.ptr,
					yyvsp[0].str.len,
					OSPF_AUTH_SIZE);
				PARSE_ERROR;
			    }

			    yyval.hex.type = yyvsp[0].str.type;
			    yyval.hex.len = OSPF_AUTH_SIZE;
			    yyval.hex.ptr = (byte *) task_mem_calloc((task *) 0, 1, OSPF_AUTH_SIZE);
			    
			    /* Left justify the authentication key */
			    (void) strncpy((caddr_t) yyval.hex.ptr, yyvsp[0].str.ptr, yyvsp[0].str.len);

			    free_charstr(&yyvsp[0].str);
			}
break;
case 246:
#line 1848 "parser.y"
{
			    int offset = OSPF_AUTH_SIZE - sizeof (yyvsp[0].num);

			    yyval.hex.type = L_NUMBER;
			    yyval.hex.len = OSPF_AUTH_SIZE;
			    yyval.hex.ptr = (byte *) task_mem_calloc((task *) 0, 1, OSPF_AUTH_SIZE);

			    /* Right justify the authentication key */
			    bcopy((caddr_t) &yyvsp[0].num, (caddr_t) yyval.hex.ptr + offset, sizeof(yyvsp[0].num));
			}
break;
case 247:
#line 1859 "parser.y"
{
			    int offset = OSPF_AUTH_SIZE - yyvsp[0].hex.len;

			    if (offset < 0) {
				sprintf(parse_error, "authentication-key longer than %d characters",
					OSPF_AUTH_SIZE);
				PARSE_ERROR;
			    }

			    yyval.hex.type = yyvsp[0].hex.type;
			    yyval.hex.len = OSPF_AUTH_SIZE;
			    yyval.hex.ptr = (byte *) task_mem_calloc((task *) 0, 1, OSPF_AUTH_SIZE);

			    /* Right justify the authentication key */
			    bcopy((caddr_t) yyvsp[0].hex.ptr, (caddr_t) yyval.hex.ptr + offset, yyvsp[0].hex.len);

			    free_bytestr(&yyvsp[0].hex);
			}
break;
case 250:
#line 1884 "parser.y"
{
			    yyerrok;
			}
break;
case 251:
#line 1890 "parser.y"
{
			    ospf_parse_add_host(ospf_AREA, sock2ip(yyvsp[-2].sockaddr), yyvsp[0].metric.metric);

			    sockfree(yyvsp[-2].sockaddr);
			}
break;
case 253:
#line 1900 "parser.y"
{
			    (yyval.ospf_router = yyvsp[-1].ospf_router)->ocr_next = yyvsp[-2].ospf_router;
			}
break;
case 254:
#line 1904 "parser.y"
{
			    yyerrok;
			}
break;
case 255:
#line 1911 "parser.y"
{
			    yyval.ospf_router = ospf_parse_router_alloc(sock2in(yyvsp[-1].gwp->gw_addr), (u_int) yyvsp[0].num);
			}
break;
case 256:
#line 1918 "parser.y"
{
			    yyval.num = 0;
			}
break;
case 257:
#line 1922 "parser.y"
{
			    yyval.num = 1;
			}
break;
case 258:
#line 1928 "parser.y"
{
			    if (parse_limit_check("priority",
						  (u_int) yyvsp[0].num,
						  OSPF_LIMIT_DRPRIORITY)) {
				PARSE_ERROR;
			    }
			    yyval.num = yyvsp[0].num;
			}
break;
case 259:
#line 1939 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_OSPF;
			    parse_gwlist = (gw_entry **) 0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 260:
#line 1950 "parser.y"
{
			    /* Make sure this PS type is known */
			    adv_psfunc_add(RTPROTO_OSPF_ASE, &ospf_adv_psfunc);

			    yyval.proto = parse_proto = RTPROTO_OSPF_ASE;
			    parse_gwlist = (gw_entry **) 0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 262:
#line 1965 "parser.y"
{
			    yyval.flag = yyvsp[-1].flag | yyvsp[0].flag;
			}
break;
case 263:
#line 1969 "parser.y"
{
			    yyval.flag = yyvsp[-2].flag & ~yyvsp[0].flag;
			}
break;
case 264:
#line 1976 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 265:
#line 1980 "parser.y"
{
			    if (sock2ip(yyvsp[-1].dm.dm_dest) == INADDR_ANY) {
				sprintf(parse_error, "invalid range %A/%A",
					yyvsp[-1].dm.dm_dest,
					yyvsp[-1].dm.dm_mask);
				PARSE_ERROR;
			    }
			    yyval.adv = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv->adv_dm = yyvsp[-1].dm;
			    yyval.adv = parse_adv_dm_append(yyvsp[-2].adv, yyval.adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			}
break;
case 266:
#line 1995 "parser.y"
{
			    yyerrok;
			}
break;
case 270:
#line 2007 "parser.y"
{ yyval.flag = TR_OSPF_DD; }
break;
case 271:
#line 2008 "parser.y"
{ yyval.flag = TR_OSPF_REQ; }
break;
case 272:
#line 2009 "parser.y"
{ yyval.flag = TR_OSPF_LSU; }
break;
case 273:
#line 2010 "parser.y"
{ yyval.flag = TR_OSPF_ACK; }
break;
case 274:
#line 2011 "parser.y"
{ yyval.flag = TR_OSPF_RX; }
break;
case 275:
#line 2012 "parser.y"
{ yyval.flag = TR_OSPF_LSA_BLD; }
break;
case 276:
#line 2013 "parser.y"
{ yyval.flag = TR_OSPF_LSA_TX; }
break;
case 277:
#line 2014 "parser.y"
{ yyval.flag = TR_OSPF_LSA_RX; }
break;
case 278:
#line 2015 "parser.y"
{ yyval.flag = TR_OSPF_SPF; }
break;
case 279:
#line 2016 "parser.y"
{ yyval.flag = TR_OSPF_TRAP; }
break;
case 280:
#line 2034 "parser.y"
{
			    PROTO_SEEN(RTPROTO_EGP);

			    egp_trace_flags = trace_flags;
			}
break;
case 281:
#line 2040 "parser.y"
{
			    switch (yyvsp[-1].num) {
			    case T_ON:
				doing_egp = TRUE;

				if (!inet_autonomous_system) {
				    (void) sprintf(parse_error, "autonomous-system not specified");
				    PARSE_ERROR;
				}
				if (!egp_neighbors) {
				    (void) sprintf(parse_error, "no EGP neighbors specified");
				    PARSE_ERROR;
				}

#if	defined(PROTO_SNMP)
				egp_sort_neighbors();
#endif	/* defined(PROTO_SNMP) */
				break;

			    case T_OFF:
				doing_egp = FALSE;
			    }
			}
break;
case 286:
#line 2072 "parser.y"
{
			    yyerrok;
			}
break;
case 287:
#line 2078 "parser.y"
{
			    egp_preference = yyvsp[0].pref;
			}
break;
case 288:
#line 2082 "parser.y"
{
			    if (parse_metric_check(RTPROTO_EGP, &yyvsp[0].metric)) {
				PARSE_ERROR;
			    }
			    egp_default_metric = yyvsp[0].metric.metric;
			}
break;
case 289:
#line 2089 "parser.y"
{
			    if (parse_limit_check("packetsize",
						  (u_int) yyvsp[0].num,
						  EGP_LIMIT_PKTSIZE)) {
				PARSE_ERROR;
			    }
			    egp_pktsize = yyvsp[0].num;
			}
break;
case 290:
#line 2098 "parser.y"
{
			    egp_trace_flags =  yyvsp[0].flag;
			}
break;
case 291:
#line 2102 "parser.y"
{
			    /* Clear group structure and set fill pointer */
			    bzero((caddr_t) &egp_group, sizeof(egp_group));
			    ngp = &egp_group;
			    ngp->ng_trace_flags = egp_trace_flags;
			    /* First neighbor in group is head of group */
			    gr_ngp = (egp_neighbor *) 0;
			    parse_group_index++;
			}
break;
case 292:
#line 2112 "parser.y"
{
			    if (gr_ngp->ng_gr_acquire > gr_ngp->ng_gr_number) {
				(void) sprintf(parse_error,
					       "maxacquire %u is greater than number of neighbors %u in group %d",
					       gr_ngp->ng_gr_acquire,
					       gr_ngp->ng_gr_number,
					       parse_group_index);
				PARSE_ERROR;
			    } else if (!gr_ngp->ng_gr_acquire) {
				gr_ngp->ng_gr_acquire = gr_ngp->ng_gr_number;
			    }

			}
break;
case 295:
#line 2130 "parser.y"
{
			    yyerrok;
			}
break;
case 296:
#line 2136 "parser.y"
{
			    ngp = egp_ngp_alloc(&egp_group);

			    /* This neighbor is head of the group */
			    if (!gr_ngp) {
				gr_ngp = ngp;
			    }
			    parse_gwlist = &parse_gwp;
			}
break;
case 297:
#line 2146 "parser.y"
{
			    int add = TRUE;
			    egp_neighbor *ngp2;

			    /* Set neighbor's address */
			    ngp->ng_addr = yyvsp[-1].sockaddr;
			    ngp->ng_gw.gw_proto = RTPROTO_EGP;
			    (void) sprintf(ngp->ng_name, "%A",
					   ngp->ng_addr);

			    /* Set group pointer and count this neighbor */
			    ngp->ng_gr_head = gr_ngp;
			    ngp->ng_gr_index = parse_group_index;
			    gr_ngp->ng_gr_number++;

			    EGP_LIST(ngp2) {
				if (sockaddrcmp_in(ngp->ng_addr, ngp2->ng_addr)) {
				    if (BIT_TEST(ngp2->ng_flags, NGF_DELETE)) {
					if (!egp_neighbor_changed(ngp2, ngp)) {
					    BIT_RESET(ngp2->ng_flags, NGF_DELETE);
					    egp_ngp_free(ngp);
					    add = FALSE;
					    break;
					} else {
					    ngp->ng_flags = NGF_WAIT;
					}
				    } else {
					(void) sprintf(parse_error, "duplicate EGP neighbor at %A",
						       ngp->ng_addr);
					PARSE_ERROR;
				    }
				}
			    } EGP_LIST_END(ngp2) ;
			    
			    /* Add this neighbor to end of the list */
			    if (add) {
				insque((struct qelem *) ngp, (struct qelem *) egp_neighbor_head.ng_back);
				egp_neighbors++;
			    }
			}
break;
case 301:
#line 2196 "parser.y"
{
			    BIT_SET(ngp->ng_options, NGO_PEERAS);
			    ngp->ng_peer_as = yyvsp[0].as;
			}
break;
case 302:
#line 2201 "parser.y"
{
			    BIT_SET(ngp->ng_options, NGO_LOCALAS);
			    ngp->ng_local_as = yyvsp[0].as;
			}
break;
case 303:
#line 2206 "parser.y"
{
			    /* XXX - Limit check maxup value */
			    BIT_SET(ngp->ng_options, NGO_MAXACQUIRE);
			    ngp->ng_gr_acquire = yyvsp[0].num;
			}
break;
case 304:
#line 2212 "parser.y"
{
			    if ( !(EGPVMASK & (1 << (yyvsp[0].num - 2))) ) {
				(void) sprintf(parse_error, "unsupported EGP version: %d",
					       yyvsp[0].num);
				PARSE_ERROR;
			    }
			    BIT_SET(ngp->ng_options, NGO_VERSION);
			    ngp->ng_version = yyvsp[0].num;
			}
break;
case 305:
#line 2222 "parser.y"
{
			    BIT_SET(ngp->ng_options, NGO_PREFERENCE);
			    ngp->ng_preference = yyvsp[0].pref;
			}
break;
case 306:
#line 2227 "parser.y"
{
			    ngp->ng_trace_flags = egp_trace_flags;
			}
break;
case 309:
#line 2238 "parser.y"
{
			    if (parse_metric_check(RTPROTO_EGP, &yyvsp[0].metric)) {
				PARSE_ERROR;
			    }
			    ngp->ng_metricout = yyvsp[0].metric.metric;
			    BIT_SET(ngp->ng_options, NGO_METRICOUT);
			}
break;
case 310:
#line 2246 "parser.y"
{
			    BIT_SET(ngp->ng_options, NGO_NOGENDEFAULT);
			}
break;
case 311:
#line 2250 "parser.y"
{
			    BIT_SET(ngp->ng_options, NGO_DEFAULTIN);
			}
break;
case 312:
#line 2254 "parser.y"
{
			    BIT_SET(ngp->ng_options, NGO_DEFAULTOUT);
			}
break;
case 313:
#line 2258 "parser.y"
{
			    BIT_SET(ngp->ng_options, NGO_GATEWAY);
			    ngp->ng_gateway = sockdup(yyvsp[0].gwp->gw_addr);
			    gw_freelist(*parse_gwlist);
			    parse_gwlist = (gw_entry **) 0;
			    parse_gwp = (gw_entry *) 0;
			}
break;
case 314:
#line 2266 "parser.y"
{
			    BIT_SET(ngp->ng_options, NGO_LCLADDR);
			    ngp->ng_lcladdr = yyvsp[0].ifae;
			}
break;
case 315:
#line 2271 "parser.y"
{
			    BIT_SET(ngp->ng_options, NGO_SADDR);
			    ngp->ng_saddr = yyvsp[0].sockaddr;
			}
break;
case 316:
#line 2276 "parser.y"
{
 			    if (parse_limit_check("P1",
						  (u_int) yyvsp[0].time,
						  EGP_LIMIT_P1)) {
 				PARSE_ERROR;
 			    }
 			    BIT_SET(ngp->ng_options, NGO_P1);
 			    ngp->ng_P1 = yyvsp[0].time;
 			}
break;
case 317:
#line 2286 "parser.y"
{
 			    if (parse_limit_check("P2",
						  (u_int) yyvsp[0].time,
						  EGP_LIMIT_P2)) {
 				PARSE_ERROR;
 			    }
 			    BIT_SET(ngp->ng_options, NGO_P2);
 			    ngp->ng_P2 = yyvsp[0].time;
			}
break;
case 319:
#line 2303 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_EGP;
			    parse_gwlist = (gw_entry **) 0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 320:
#line 2318 "parser.y"
{
			    PROTO_SEEN(RTPROTO_BGP);

			    parse_gwlist = &parse_gwp;

			    bgp_default_trace_flags = trace_flags;
			}
break;
case 321:
#line 2326 "parser.y"
{
			    switch (yyvsp[-1].num) {
			    case T_ON:
				doing_bgp = TRUE;

				if (!bgp_conf_check(parse_error)) {
				    PARSE_ERROR;
				}
				break;

			    case T_OFF:
				doing_bgp = FALSE;
			    }

			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 326:
#line 2351 "parser.y"
{
			    yyerrok;
			}
break;
case 327:
#line 2357 "parser.y"
{
			    bgp_default_preference = yyvsp[0].pref;
			}
break;
case 328:
#line 2361 "parser.y"
{
			    if (parse_metric_check(RTPROTO_BGP, &yyvsp[0].metric)) {
				PARSE_ERROR;
			    }
			    bgp_default_metric = yyvsp[0].metric.metric;
			}
break;
case 329:
#line 2368 "parser.y"
{
			    bgp_default_trace_flags = yyvsp[0].flag;
			}
break;
case 330:
#line 2372 "parser.y"
{
			    /* Allocate a Group structure */
			    bgp = bgp_conf_group_alloc();

			    /* Set the type and AS */
			    bgp->bgpg_type = yyvsp[-2].num;
			    bgp->bgpg_peer_as = yyvsp[0].as;

			    /* Point at this configuration information */
			    bcp = &bgp->bgpg_conf;

			    /* Inherit global trace flags */
			    bgp->bgpg_trace_flags = bgp_default_trace_flags;
			}
break;
case 331:
#line 2387 "parser.y"
{
			    /* Add this group */
			    bgp = bgp_conf_group_add(bgp, parse_error);
			    if (!bgp) {
				PARSE_ERROR;
			    }
			}
break;
case 332:
#line 2395 "parser.y"
{
			    /* Check group */
			    if (!bgp_conf_group_check(bgp, parse_error)) {
				PARSE_ERROR;
			    }
			}
break;
case 337:
#line 2411 "parser.y"
{
				yyerrok;
			}
break;
case 338:
#line 2417 "parser.y"
{
			    /* Allocate this peer */
			    bnp = bgp_conf_peer_alloc(bgp);

			    /* Point at this configuration information */
			    bcp = &bnp->bgp_conf;
			}
break;
case 339:
#line 2425 "parser.y"
{
			    /* Set peer address */
			    bnp->bgp_addr = yyvsp[-1].sockaddr;

			    bnp = bgp_conf_peer_add(bgp, bnp, parse_error);
			    if (!bnp) {
				PARSE_ERROR;
			    }
			}
break;
case 340:
#line 2435 "parser.y"
{
			    parse_contig_masks = FALSE;
			}
break;
case 341:
#line 2439 "parser.y"
{
			    parse_contig_masks = TRUE;

			    if (parse_adv_append(&bgp->bgpg_allow, yyvsp[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 342:
#line 2449 "parser.y"
{
			    if (parse_metric_check(RTPROTO_BGP, &yyvsp[0].metric)) {
				PARSE_ERROR;
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_METRIC_OUT);
			    bcp->bgpc_metric_out = yyvsp[0].metric.metric;
			}
break;
case 343:
#line 2457 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_LOCAL_AS);
			    bcp->bgpc_local_as = yyvsp[0].as;
			}
break;
case 344:
#line 2462 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_NOGENDEFAULT);
			}
break;
case 345:
#line 2466 "parser.y"
{
			    if (bcp->bgpc_gateway) {
				/* Free the old one */
				sockfree(bcp->bgpc_gateway);
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_GATEWAY);
			    bcp->bgpc_gateway = sockdup(yyvsp[0].gwp->gw_addr);
			    gw_freelist(*parse_gwlist);
			    *parse_gwlist = parse_gwp = (gw_entry *) 0;
			}
break;
case 346:
#line 2477 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_PREFERENCE);
			    bcp->bgpc_preference = yyvsp[0].pref;
			}
break;
case 347:
#line 2482 "parser.y"
{
			    if (bcp->bgpc_lcladdr) {
				/* Free the old one */
				ifae_free(bcp->bgpc_lcladdr);
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_LCLADDR);
			    bcp->bgpc_lcladdr = yyvsp[0].ifae;
			}
break;
case 348:
#line 2491 "parser.y"
{
			    if (parse_limit_check("hold time",
						  (u_int) yyvsp[0].time,
						  BGP_LIMIT_HOLDTIME)) {
				PARSE_ERROR;
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_HOLDTIME);
			    bcp->bgpc_holdtime_out = yyvsp[0].time;
			}
break;
case 349:
#line 2501 "parser.y"
{
			    bcp->bgpc_trace_flags = yyvsp[0].flag;
			}
break;
case 350:
#line 2505 "parser.y"
{
			    if (!BGP_KNOWN_VERSION(yyvsp[0].num)) {
				(void) sprintf(parse_error, "unsupported BGP version: %d",
					       yyvsp[0].num);
				PARSE_ERROR;
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_VERSION);
			    bcp->bgpc_conf_version = yyvsp[0].num;
			}
break;
case 351:
#line 2515 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_PASSIVE);
			}
break;
case 352:
#line 2519 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_DEFAULTIN);
			}
break;
case 353:
#line 2523 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_DEFAULTOUT);
			}
break;
case 354:
#line 2527 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_KEEPALL);
			}
break;
case 355:
#line 2531 "parser.y"
{
			    bcp->bgpc_send_bufsize = yyvsp[0].num;
			}
break;
case 356:
#line 2535 "parser.y"
{
			    bcp->bgpc_recv_bufsize = yyvsp[0].num;
			}
break;
case 357:
#line 2539 "parser.y"
{
			    if (parse_limit_check("spool buffer size",
						  (u_int) yyvsp[0].num,
						  BGP_LIMIT_SBUF)) {
				PARSE_ERROR;
			    }
			    bcp->bgpc_spool_bufsize = yyvsp[0].num;
			}
break;
case 358:
#line 2550 "parser.y"
{
			    if (parse_limit_check("kernel buffer size",
						  (u_int) yyvsp[0].num,
						  BGP_LIMIT_KBUF)) {
				PARSE_ERROR;
			    }
			    yyval.num = yyvsp[0].num;
			}
break;
case 359:
#line 2561 "parser.y"
{
			    yyval.num = BGPG_INTERNAL;
			}
break;
case 360:
#line 2565 "parser.y"
{
			    yyval.num = BGPG_EXTERNAL;
			}
break;
case 361:
#line 2569 "parser.y"
{
			    yyval.num = BGPG_INTERNAL_IGP;
			}
break;
case 362:
#line 2573 "parser.y"
{
			    yyval.num = BGPG_TEST;
			}
break;
case 364:
#line 2584 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_BGP;
			    parse_gwlist = (gw_entry **) 0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 365:
#line 2595 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 366:
#line 2599 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv->adv_dm = yyvsp[-1].dm;
			    yyval.adv = parse_adv_dm_append(yyvsp[-2].adv, yyval.adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			}
break;
case 367:
#line 2608 "parser.y"
{
			    yyerrok;
			}
break;
case 371:
#line 2624 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    PROTO_SEEN(RTPROTO_REDIRECT);

			    parse_gwlist = &redirect_gw_list;

			    redirect_trace_flags = trace_flags;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 372:
#line 2634 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    switch (yyvsp[-1].num) {
			    case T_ON:
				/* Enabled by default */
				break;

			    case T_OFF:
				redirect_disable(RTPROTO_REDIRECT);
				break;
			    }
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 377:
#line 2657 "parser.y"
{
			    yyerrok;
			}
break;
case 378:
#line 2663 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    redirect_preference = yyvsp[0].pref;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 379:
#line 2669 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    config_list *list = config_list_alloc(yyvsp[0].config, 0);

			    parse_adv_propagate_config(yyvsp[-1].adv, list, RTPROTO_REDIRECT);

			    if (parse_adv_append(&redirect_int_policy, yyvsp[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }

			    config_list_free(list);
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 380:
#line 2683 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    redirect_n_trusted += parse_gw_flag(yyvsp[0].adv, RTPROTO_REDIRECT, GWF_TRUSTED);
			    if (!redirect_n_trusted) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 381:
#line 2692 "parser.y"
{
			    redirect_trace_flags = yyvsp[0].flag;
			}
break;
case 383:
#line 2700 "parser.y"
{
			    yyval.config = config_append(yyvsp[-1].config, yyvsp[0].config);
			    if (!yyval.config) {
				PARSE_ERROR;
			    }
			}
break;
case 384:
#line 2710 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    yyval.config = config_alloc(REDIRECT_CONFIG_NOIN, (void_t) TRUE);
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 386:
#line 2731 "parser.y"
{
			    if (parse_new_state(PS_ROUTE)) {
				PARSE_ERROR;
			    }
			}
break;
case 387:
#line 2739 "parser.y"
{
			    /* Need to set this for static routes, not used for interface routes */
			    parse_proto = RTPROTO_STATIC;
			    parse_gwlist = &rt_gw_list;
			    rt_open(rt_task);
			}
break;
case 388:
#line 2746 "parser.y"
{
			    rt_close(rt_task, (gw_entry *) 0, 0, NULL);
			}
break;
case 391:
#line 2754 "parser.y"
{
				yyerrok;
			}
break;
case 392:
#line 2760 "parser.y"
{
			    /* Route to a gateway */

			    if (rt_parse_route(yyvsp[-5].dm.dm_dest,
					       yyvsp[-5].dm.dm_mask,
					       yyvsp[-3].adv,
					       yyvsp[-2].adv,
					       PARSE_METRIC_ISSET(&yyvsp[-1].metric) ? (pref_t) yyvsp[-1].metric.metric : RTPREF_STATIC,
					       yyvsp[0].flag | RTS_GATEWAY,
					       parse_error)) {
				PARSE_ERROR;
			    }

			    sockfree(yyvsp[-5].dm.dm_dest);
			}
break;
case 393:
#line 2776 "parser.y"
{
			    /* Route to an interface */

			    if (rt_parse_route(yyvsp[-4].dm.dm_dest,
					       yyvsp[-4].dm.dm_mask,
					       (adv_entry *) 0,
					       yyvsp[-2].adv,
					       PARSE_METRIC_ISSET(&yyvsp[-1].metric) ? (pref_t) yyvsp[-1].metric.metric : RTPREF_STATIC,
					       yyvsp[0].flag,
					       parse_error)) {
				PARSE_ERROR;
			    }

			    sockfree(yyvsp[-4].dm.dm_dest);
			}
break;
case 396:
#line 2796 "parser.y"
{
			    yyval.dm.dm_dest = sockdup(inet_addr_default);
			    yyval.dm.dm_mask = inet_mask_default;
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			}
break;
case 397:
#line 2807 "parser.y"
{
			    yyval.flag = 0;
			}
break;
case 398:
#line 2811 "parser.y"
{
			    yyval.flag = yyvsp[-1].flag | yyvsp[0].flag;
			}
break;
case 399:
#line 2817 "parser.y"
{
			    yyval.flag = RTS_RETAIN;
			}
break;
case 400:
#line 2821 "parser.y"
{
			    yyval.flag = RTS_REJECT;
			}
break;
case 401:
#line 2825 "parser.y"
{
			    yyval.flag = RTS_BLACKHOLE;
			}
break;
case 402:
#line 2829 "parser.y"
{
			    yyval.flag = RTS_NOTINSTALL;
			}
break;
case 403:
#line 2837 "parser.y"
{
			    if (parse_new_state(PS_CONTROL)) {
				PARSE_ERROR;
			    }
			}
break;
case 404:
#line 2846 "parser.y"
{
#if	defined(PROTO_EGP) || defined(PROTO_BGP)
			    adv_entry *adv;
			    pmet_t *pp = &yyvsp[-1].metric_adv.metric;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_AS, yyvsp[-4].proto_lists.proto);
			    adv->adv_as = yyvsp[-2].as;
			    adv->adv_list = yyvsp[-1].metric_adv.adv;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(adv->adv_flag, ADVFOT_PREFERENCE);
				    adv->adv_result.res_preference = pp->metric;
				}
			    }

			    if (!parse_adv_as(yyvsp[-4].proto_lists.import_list, adv)) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_EGP) || defined(PROTO_BGP) */
			}
break;
case 405:
#line 2873 "parser.y"
{
			    adv_entry *adv;
			    pmet_t *pp = &yyvsp[-1].metric_adv.metric;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_ASPATH, RTPROTO_BGP);
			    adv->adv_aspath = (caddr_t) yyvsp[-2].asp_match;
			    adv->adv_list = yyvsp[-1].metric_adv.adv;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(adv->adv_flag, ADVFOT_PREFERENCE);
				    adv->adv_result.res_preference = pp->metric;
				}
			    }

			    if (parse_adv_append(&bgp_import_aspath_list, adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 406:
#line 2898 "parser.y"
{
			    /*
			     *	Append the dest_mask list to the end of the import list
			     *	for the specified protocol.
			     */
			    if (!parse_adv_propagate_preference(yyvsp[-2].adv, yyvsp[-3].proto_lists.proto, &yyvsp[-1].metric_adv.metric, yyvsp[-1].metric_adv.adv)) {
				PARSE_ERROR;
			    }

			    adv_free_list(yyvsp[-1].metric_adv.adv);

			    switch (yyvsp[-2].adv->adv_flag & ADVF_TYPE) {
			    case ADVFT_GW:
				/* Gateway list */
			        {
				    adv_entry *adv = yyvsp[-2].adv;
				    adv_entry *advn;

				    do {
					advn = adv->adv_next;
					adv->adv_next = NULL;
					/* Reset the type */
					adv->adv_flag = (adv->adv_flag & ~ADVF_TYPE) | ADVFT_ANY;
					if (parse_adv_append(&adv->adv_gwp->gw_import, adv, TRUE)) {
					    PARSE_ERROR;
					}
				    } while (adv = advn);
				}
				break;

			    case ADVFT_ANY:
				/* Global list */
				if (parse_adv_append(yyvsp[-3].proto_lists.import_list, yyvsp[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    case ADVFT_IFN:
			    case ADVFT_IFAE:
				/* Interface list */
				if (parse_adv_append(&int_import[yyvsp[-3].proto_lists.proto], yyvsp[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    default:
				assert(FALSE);
			    }
			}
break;
case 407:
#line 2948 "parser.y"
{
			    adv_entry *adv;
			    pmet_t *pp = &yyvsp[-1].metric_adv.metric;

			    /* Make sure this PS type is known */
			    adv_psfunc_add(RTPROTO_OSPF_ASE, &ospf_adv_psfunc);

			    /*
			     *	Append the dest_mask list to the end of the OSPF import list.
			     */
			    adv = adv_alloc(ADVFT_PS, RTPROTO_OSPF_ASE);
			    adv->adv_list = yyvsp[-1].metric_adv.adv;
			    adv->adv_ps = (caddr_t) adv;

			    /* Set Tag */
			    if (PARSE_METRIC_ISSET(&yyvsp[-2].metric)) {
				BIT_SET(adv->adv_flag, ADVFOT_METRIC);
				BIT_SET(adv->adv_result.res_flag, OSPF_EXPORT_TAG);
				adv->adv_result.res_metric = yyvsp[-2].metric.metric;
			    }

			    /* Set Preference */
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(adv->adv_flag, ADVFOT_PREFERENCE);
				    adv->adv_result.res_preference = pp->metric;
				}
			    }

			    if (parse_adv_append(&ospf.import_list, adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 408:
#line 2984 "parser.y"
{
#if	defined(PROTO_EGP) || defined(PROTO_BGP)
			    adv_entry *adv;
			    adv_entry *adv_prop = yyvsp[-1].metric_adv.adv;
			    pmet_t *mp = &yyvsp[-1].metric_adv.metric;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_AS, yyvsp[-4].proto_lists.proto);
			    adv->adv_as = yyvsp[-2].as;
			    adv->adv_list = adv_prop;
			    if (PARSE_METRIC_ISRESTRICT(mp)) {
				BIT_SET(adv->adv_flag, ADVF_NO);
			    } else if (PARSE_METRIC_ISSET(mp)) {
				BIT_SET(adv->adv_flag, ADVFOT_METRIC);
				adv->adv_result.res_metric = mp->metric;
			    }

			    if (!parse_adv_as(yyvsp[-4].proto_lists.export_list, adv)) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_EGP) || defined(PROTO_BGP) */
			}
break;
case 409:
#line 3010 "parser.y"
{
			    /*
			     *	Append the dest_mask list to the end of the export list
			     *	for the specified protocol.
			     */

			    if (!parse_adv_propagate_metric(yyvsp[-2].adv, yyvsp[-3].proto_lists.proto, &yyvsp[-1].metric_adv.metric, yyvsp[-1].metric_adv.adv)) {
				PARSE_ERROR;
			    }

			    adv_free_list(yyvsp[-1].metric_adv.adv);

			    switch (yyvsp[-2].adv->adv_flag & ADVF_TYPE) {
			    case ADVFT_GW:
				/* Gateway list */
			        {
				    adv_entry *adv = yyvsp[-2].adv;
				    adv_entry *advn;
				
				    do {
					advn = adv->adv_next;
					adv->adv_next = NULL;
					if (parse_adv_append(&adv->adv_gwp->gw_export, adv, TRUE)) {
					    PARSE_ERROR;
					}
				    } while (adv = advn);
				}
				break;

			    case ADVFT_ANY:
				/* Global list for the protocol */
				if (parse_adv_append(yyvsp[-3].proto_lists.export_list, yyvsp[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    case ADVFT_IFN:
			    case ADVFT_IFAE:
				/* Interface list */
				if (parse_adv_append(&int_export[yyvsp[-3].proto_lists.proto], yyvsp[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    default:
				assert(FALSE);
			    }
			}
break;
case 410:
#line 3059 "parser.y"
{
			    adv_entry *adv;
			    adv_entry *adv_prop = yyvsp[-1].metric_adv.adv;
			    pmet_t *mp = &yyvsp[-1].metric_adv.metric;

			    /* If we export then we are a border router */
			    IAmASBorderRtr = TRUE;

			    /* Make sure this PS type is known */
			    adv_psfunc_add(RTPROTO_OSPF_ASE, &ospf_adv_psfunc);

			    /*
			     *	Append the dest_mask list to the end of the export list
			     *	for the specified protocol.
			     */
			    adv = adv_alloc(ADVFT_PS, RTPROTO_OSPF_ASE);
			    adv->adv_ps = (caddr_t) adv;
			    adv->adv_list = adv_prop;

			    /* Metric */
			    if (PARSE_METRIC_ISRESTRICT(mp)) {
				BIT_SET(adv->adv_flag, ADVF_NO);
			    } else if (PARSE_METRIC_ISSET(mp)) {
				BIT_SET(adv->adv_flag, ADVFOT_METRIC);
				adv->adv_result.res_metric = mp->metric;
			    }

			    /* Type */
			    if (PARSE_METRIC_ISSET(&yyvsp[-3].metric)) {
				BIT_SET(adv->adv_flag, ADVFOT_FLAG);
				adv->adv_result.res_flag = yyvsp[-3].metric.metric;
			    }

			    /* Tag */
			    switch (yyvsp[-2].metric.state) {
			    case PARSE_METRICS_SET:
				BIT_SET(adv->adv_flag, ADVFOT_METRIC2|ADVFOT_FLAG);
				BIT_SET(adv->adv_result.res_flag, OSPF_EXPORT_TAG|OSPF_EXPORT_TAG_METRIC2);
				adv->adv_result.res_metric2 = yyvsp[-2].metric.metric;
				break;

			    case PARSE_METRICS_ALTERNATE:
				BIT_SET(adv->adv_flag, ADVFOT_METRIC2|ADVFOT_FLAG);
				BIT_SET(adv->adv_result.res_flag, OSPF_EXPORT_TAG|OSPF_EXPORT_TAG_METRIC2);
				adv->adv_result.res_metric2 = PATH_OSPF_TAG_TRUSTED |
				    ((yyvsp[-2].metric.metric << PATH_OSPF_TAG_USR_SHIFT) & PATH_OSPF_TAG_USR_MASK);
				break;
			    }

			    if (parse_adv_append(&ospf.export_list, adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 411:
#line 3122 "parser.y"
{
			    parse_export_proto = yyval.proto_lists.proto = yyvsp[0].proto;

			    switch (yyvsp[0].proto) {
#if	defined(PROTO_EGP)
			    case RTPROTO_EGP:
				yyval.proto_lists.import_list = &egp_import_list;
				yyval.proto_lists.export_list = &egp_export_list;
				break;
#endif

#if	defined(PROTO_BGP)
			    case RTPROTO_BGP:
				yyval.proto_lists.import_list = &bgp_import_list;
				yyval.proto_lists.export_list = &bgp_export_list;
				break;
#endif

			    default:
				(void) sprintf(parse_error,
					       "unknown import protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto)));
				PARSE_ERROR;
			    }
			}
break;
case 412:
#line 3151 "parser.y"
{
			    yyval.proto_lists = yyvsp[0].proto_lists;
			    
			    parse_proto = yyvsp[0].proto_lists.proto;
			    parse_gwlist = yyvsp[0].proto_lists.gw_list;

			    if (!yyvsp[0].proto_lists.import_list) {
				(void) sprintf(parse_error,
					       "unknown import protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists.proto)));
				PARSE_ERROR;
			    }
			    
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists.proto)));
			}
break;
case 413:
#line 3172 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv.metric);
			    yyval.metric_adv.adv = (adv_entry *) 0;
			}
break;
case 414:
#line 3177 "parser.y"
{
			    yyval.metric_adv.metric = yyvsp[-3].metric;
			    yyval.metric_adv.adv = yyvsp[-1].adv;
			}
break;
case 415:
#line 3184 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 416:
#line 3188 "parser.y"
{
			    
			    yyval.adv = parse_adv_dm_append(yyvsp[-2].adv, yyvsp[-1].adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			}
break;
case 417:
#line 3196 "parser.y"
{
			    yyerrok;
			}
break;
case 418:
#line 3202 "parser.y"
{
			    parse_contig_masks = FALSE;
			}
break;
case 419:
#line 3206 "parser.y"
{
			    parse_contig_masks = TRUE;

			    yyval.adv = adv_alloc(ADVFT_DM, parse_proto);
			    yyval.adv->adv_dm = yyvsp[-1].dm;
			    if (PARSE_METRIC_ISSET(&yyvsp[0].metric)) {
				if (PARSE_METRIC_ISRESTRICT(&yyvsp[0].metric)) {
				    BIT_SET(yyval.adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(yyval.adv->adv_flag, ADVFOT_PREFERENCE);
				    yyval.adv->adv_result.res_preference = yyvsp[0].metric.metric;
				}
			    }
			}
break;
case 420:
#line 3227 "parser.y"
{
			    yyval.proto_lists = yyvsp[0].proto_lists;
			    
			    parse_export_proto = parse_proto = yyvsp[0].proto_lists.proto;
			    parse_gwlist = yyvsp[0].proto_lists.gw_list;

			    if (!yyvsp[0].proto_lists.export_list) {
				(void) sprintf(parse_error,
					       "unknown export protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists.proto)));
				PARSE_ERROR;
			    }
			    
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists.proto)));
			}
break;
case 421:
#line 3248 "parser.y"
{
			    yyval.proto = parse_export_proto = RTPROTO_OSPF_ASE;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 422:
#line 3259 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv.metric);
			    yyval.metric_adv.adv = (adv_entry *) 0;
			}
break;
case 423:
#line 3264 "parser.y"
{
			    yyval.metric_adv.metric = yyvsp[-3].metric;
			    yyval.metric_adv.adv = yyvsp[-1].adv;
			}
break;
case 424:
#line 3272 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 425:
#line 3276 "parser.y"
{
			    yyval.adv = yyvsp[-2].adv;
			    if (parse_adv_append(&yyval.adv, yyvsp[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 426:
#line 3283 "parser.y"
{
			    yyerrok;
			}
break;
case 427:
#line 3289 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_AS | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_as = yyvsp[-1].as;
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yyvsp[-3].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 428:
#line 3296 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ASPATH | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_aspath = (caddr_t) yyvsp[-1].asp_match;
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yyvsp[-2].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 429:
#line 3303 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_TAG|ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_tag = yyvsp[-1].metric.metric;
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yyvsp[-3].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 430:
#line 3310 "parser.y"
{
			    yyval.adv = parse_adv_propagate_metric(yyvsp[-1].adv, yyvsp[-2].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 431:
#line 3315 "parser.y"
{
			    yyval.adv = parse_adv_propagate_metric(yyvsp[-1].adv, yyvsp[-2].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 432:
#line 3320 "parser.y"
{
			    yyval.adv = parse_adv_propagate_metric(yyvsp[-1].adv, yyvsp[-2].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 433:
#line 3325 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ANY | ADVF_FIRST, (proto_t) 0);
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yyvsp[-1].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 434:
#line 3331 "parser.y"
{
			    yyval.adv = parse_adv_propagate_metric(yyvsp[-1].adv, yyvsp[-2].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 435:
#line 3336 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ANY | ADVF_FIRST, (proto_t) 0);
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yyvsp[-1].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 436:
#line 3341 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ANY | ADVF_FIRST, (proto_t) 0);
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yyvsp[-1].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 437:
#line 3348 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_DIRECT;
			    parse_gwlist = (gw_entry **)0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 438:
#line 3358 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_STATIC;
			    parse_gwlist = &rt_gw_list;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 439:
#line 3368 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_KERNEL;
			    parse_gwlist = &krt_gw_list;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 440:
#line 3378 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_DEFAULT;
			    parse_gwlist = (gw_entry **)0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 441:
#line 3389 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv.metric);
			    yyval.metric_adv.adv = (adv_entry *) 0;
			}
break;
case 442:
#line 3394 "parser.y"
{
			    yyval.metric_adv.metric = yyvsp[-1].metric;
			    yyval.metric_adv.adv = yyvsp[0].adv;
			}
break;
case 443:
#line 3402 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 444:
#line 3406 "parser.y"
{
			    yyval.adv = yyvsp[-1].adv;
			}
break;
case 445:
#line 3414 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 446:
#line 3418 "parser.y"
{
			    yyval.adv = parse_adv_dm_append(yyvsp[-2].adv, yyvsp[-1].adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			}
break;
case 447:
#line 3425 "parser.y"
{
			    yyerrok;
			}
break;
case 448:
#line 3431 "parser.y"
{
			    parse_contig_masks = FALSE;
			}
break;
case 449:
#line 3435 "parser.y"
{
			    parse_contig_masks = TRUE;

			    yyval.adv = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv->adv_dm = yyvsp[-1].dm;
			    if (PARSE_METRIC_ISRESTRICT(&yyvsp[0].metric)) {
				BIT_SET(yyval.adv->adv_flag, ADVF_NO);
			    } else if (PARSE_METRIC_ISSET(&yyvsp[0].metric)) {
				yyval.adv->adv_result.res_metric = yyvsp[0].metric.metric;
				BIT_SET(yyval.adv->adv_flag, ADVFOT_METRIC);
			    }
			}
break;
case 450:
#line 3454 "parser.y"
{
			    assert(FALSE);
			}
break;
case 451:
#line 3458 "parser.y"
{
			    yyval.sockaddr = sockdup(sockbuild_in(0, yyvsp[0].in_addr.s_addr));

			    trace(TR_PARSE, 0, "parse: %s IP_ADDR: %A",
				  parse_where(),
				  yyval.sockaddr);
			}
break;
case 456:
#line 3476 "parser.y"
{
			    yyval.dm.dm_dest = yyval.dm.dm_mask = (sockaddr_un *) 0;
			    trace(TR_PARSE, 0, "parse: %s DEST: all",
				  parse_where());
			}
break;
case 457:
#line 3484 "parser.y"
{
			    assert(FALSE);
			}
break;
case 458:
#line 3488 "parser.y"
{
			    yyval.dm.dm_dest = sockdup(inet_addr_default);
			    yyval.dm.dm_mask = inet_mask_host;
			    trace(TR_PARSE, 0, "parse: %s DEST: %A",
				  parse_where(),
				  yyval.dm.dm_dest);
			}
break;
case 459:
#line 3498 "parser.y"
{
			    assert(FALSE);
			}
break;
case 460:
#line 3502 "parser.y"
{
			    yyval.sockaddr = inet_mask_locate(yyvsp[0].in_addr.s_addr);
			    if (!yyval.sockaddr) {
				if (parse_contig_masks) {
				    (void) sprintf(parse_error, "mask not contiguous");
				    PARSE_ERROR;
				} else {
				    yyval.sockaddr = mask_locate(sockbuild_in(0, yyvsp[0].in_addr.s_addr));
				}
			    }
			    trace(TR_PARSE, 0, "parse: %s MASK: %A",
				  parse_where(),
				  yyval.sockaddr);
			}
break;
case 461:
#line 3520 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_GW | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_gwp = yyvsp[0].gwp;
			}
break;
case 462:
#line 3525 "parser.y"
{
			    adv_entry *adv = adv_alloc(ADVFT_GW, (proto_t) 0);

			    adv->adv_gwp = yyvsp[0].gwp;
			    yyval.adv = yyvsp[-1].adv;
			    if (parse_adv_append(&yyval.adv, adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 463:
#line 3538 "parser.y"
{
			    /*
			     *	Make sure host is on a locally attached network then
			     *	find or create a gw structure for it.  Requires that
			     *	parse_proto and parse_gwlist are previously set
			     */
			    if (!if_parse_withdst(yyvsp[0].sockaddr)) {
				(void) sprintf(parse_error, "gateway not a host address on an attached network: '%A'",
					       yyvsp[0].sockaddr);
				if (BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    PARSE_ERROR;
				} else {
				    yyerror(parse_error);
				}
			    }
			    if (!parse_gwlist) {
				(void) sprintf(parse_error, "gateway specification not valid for %s",
					       trace_state(rt_proto_bits, parse_proto));
				PARSE_ERROR;
			    }
			    yyval.gwp = gw_locate(parse_gwlist,
					   parse_proto,
					   (task *) 0,
					   (as_t) 0,
					   (as_t) 0,
					   (time_t) 0,
					   yyvsp[0].sockaddr,
					   (flag_t) 0);
			    trace(TR_PARSE, 0, "parse: %s GATEWAY: %A  PROTO: %s",
				  parse_where(),
				  yyval.gwp->gw_addr,
				  gd_lower(trace_state(rt_proto_bits, yyval.gwp->gw_proto)));
			    sockfree(yyvsp[0].sockaddr);
			}
break;
case 464:
#line 3576 "parser.y"
{ 
			    sockaddr_un *addr;

			    if (BIT_TEST(task_state, TASKS_NORESOLV)
				|| !(addr = parse_addr_hostname(yyvsp[0].str.ptr))) {
				PARSE_ERROR;
			    }
			    yyval.sockaddr = sockdup(addr);
			    trace(TR_PARSE, 0, "parse: %s HOST: %A",
				  parse_where(),
				  yyval.sockaddr);
			    free_charstr(&yyvsp[0].str);
			}
break;
case 465:
#line 3590 "parser.y"
{
			    yyval.sockaddr = yyvsp[0].sockaddr;
			    trace(TR_PARSE, 0, "parse: %s HOST: %A",
				  parse_where(),
				  yyval.sockaddr);
			}
break;
case 466:
#line 3599 "parser.y"
{
			    yyval.dm.dm_dest = yyvsp[0].sockaddr;
			    yyval.dm.dm_mask = sockhostmask(yyvsp[0].sockaddr);

			    trace(TR_PARSE, 0, "parse: %s DEST: %A",
				  parse_where(),
				  yyval.dm.dm_dest);
			}
break;
case 467:
#line 3611 "parser.y"
{
			    sockaddr_un *addr;

			    if (BIT_TEST(task_state, TASKS_NORESOLV)
				|| !(addr = parse_addr_netname(yyvsp[0].str.ptr))) {
				PARSE_ERROR;
			    }
			    yyval.sockaddr = sockdup(addr);
			    trace(TR_PARSE, 0, "parse: %s NETWORK: %A",
				  parse_where(),
				  yyval.sockaddr);
			    free_charstr(&yyvsp[0].str);
			}
break;
case 468:
#line 3625 "parser.y"
{
			    yyval.sockaddr = yyvsp[0].sockaddr;
			    trace(TR_PARSE, 0, "parse: %s NETWORK: %A",
				  parse_where(),
				  yyval.sockaddr);
			}
break;
case 469:
#line 3634 "parser.y"
{
			    yyval.dm.dm_dest = yyvsp[0].sockaddr;
			    switch (socktype(yyvsp[0].sockaddr)) {
#ifdef	PROTO_INET
			    case AF_INET:
				yyval.dm.dm_mask = inet_mask_natural(yyvsp[0].sockaddr);
				if (sock2ip(yyval.dm.dm_dest) & ~sock2ip(yyval.dm.dm_mask)) {
				    sprintf(parse_error, "host or mask option needed");
				    PARSE_ERROR;
				}
				break;
#endif	/* PROTO_INET */
#ifdef	PROTO_ISO
			    case AF_ISO:
				yyval.dm.dm_mask = iso_mask_natural(yyvsp[0].sockaddr);
				break;
#endif	/* PROTO_ISO */
			    default:
				assert(FALSE);
			    }
			    
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			}
break;
case 470:
#line 3661 "parser.y"
{
			    yyval.dm.dm_dest = yyvsp[-2].sockaddr;
			    switch (socktype(yyvsp[-2].sockaddr)) {
#ifdef	PROTO_INET
			    case AF_INET:
				if (parse_limit_check("inet mask bits",
						      (u_int) yyvsp[0].num,
						      INET_LIMIT_MASKLEN)) {
				    PARSE_ERROR;
				}
				yyval.dm.dm_mask = inet_masks[yyvsp[0].num];
				break;
#endif	/* PROTO_INET */
#ifdef	PROTO_ISO
			    case AF_ISO:
				if (parse_limit_check("iso mask bits",
						      (u_int) yyvsp[0].num,
						      ISO_LIMIT_MASKLEN)) {
				    PARSE_ERROR;
				}
				yyval.dm.dm_mask = iso_masks[yyvsp[0].num];
				break;
#endif	/* PROTO_ISO */
			    default:
				assert(FALSE);
			    }
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			}
break;
case 471:
#line 3693 "parser.y"
{
			    register byte *ap = yyvsp[-2].sockaddr->a.sa_data;
			    register byte *mp = yyvsp[0].sockaddr->a.sa_data;
			    register byte *alp = (byte *) yyvsp[-2].sockaddr + socksize(yyvsp[-2].sockaddr);
			    register byte *mlp = (byte *) yyvsp[0].sockaddr + socksize(yyvsp[0].sockaddr);

			    if (socktype(yyvsp[-2].sockaddr) != socktype(yyvsp[0].sockaddr)) {
				sprintf(parse_error, "Network %A and mask %A are not the same family",
					yyvsp[-2].sockaddr,
					yyvsp[0].sockaddr);
				PARSE_ERROR;
			    }
			    
			    /* Skip zero fields */
			    while (!*ap && ap < alp) {
				ap++, mp++;
			    }
			    
			    while (ap < alp) {
				if (mp < mlp) {
				    if (*ap++ & ~*mp++) {
					break;
				    }
				} else {
				    if (*ap++) {
					break;
				    }
				}
			    }
			    if (ap < alp) {
				sprintf(parse_error, "Non-masked bits not zero for %A mask %A",
					yyvsp[-2].sockaddr,
					yyvsp[0].sockaddr);
				PARSE_ERROR;
			    }

			    yyval.dm.dm_dest = yyvsp[-2].sockaddr;
			    yyval.dm.dm_mask = yyvsp[0].sockaddr;
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			}
break;
case 472:
#line 3740 "parser.y"
{
			    u_int32 addr = yyvsp[0].num;
			    
			    if (addr) {
				/* Normalize the address */
				while (!(addr & 0xff000000)) {
				    addr <<= 8;
				}
			    }
			    yyval.in_addr.s_addr = htonl(addr);
			}
break;
case 473:
#line 3752 "parser.y"
{
			    int i;
			    u_int32 addr = 0;

			    if (yyvsp[0].hex.len > sizeof(addr)) {
				sprintf(parse_error, "octet or hex string too long to be an IP address");
				PARSE_ERROR;
			    }

			    for (i = 0; i < sizeof(addr); i++) {
				addr <<= 8;
				if (i < yyvsp[0].hex.len) {
				    BIT_SET(addr, yyvsp[0].hex.ptr[i]);
				}
			    }
			    yyval.in_addr.s_addr = htonl(addr);
			    free_bytestr(&yyvsp[0].hex);
			}
break;
case 474:
#line 3774 "parser.y"
{
			    yyval.str = yyvsp[0].str;
			    yyval.str.ptr = task_mem_strdup((task *) 0, yyvsp[0].str.ptr);
			}
break;
case 475:
#line 3779 "parser.y"
{
			    yyval.str = yyvsp[0].str;
			    yyval.str.ptr = task_mem_strdup((task *) 0, yyvsp[0].str.ptr);
			}
break;
case 477:
#line 3788 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    yyval.proto_lists.proto = RTPROTO_REDIRECT;
			    yyval.proto_lists.import_list = &redirect_import_list;
			    yyval.proto_lists.export_list = (adv_entry **) 0;
			    yyval.proto_lists.gw_list = &redirect_gw_list;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 478:
#line 3797 "parser.y"
{
			    yyval.proto_lists.proto = RTPROTO_RIP;
			    yyval.proto_lists.import_list = &rip_import_list;
			    yyval.proto_lists.export_list = &rip_export_list;
			    yyval.proto_lists.gw_list = &rip_gw_list;
			}
break;
case 479:
#line 3807 "parser.y"
{
			    assert(FALSE);
			}
break;
case 482:
#line 3814 "parser.y"
{ yyval.num = T_ON; }
break;
case 483:
#line 3815 "parser.y"
{ yyval.num = T_OFF; }
break;
case 484:
#line 3821 "parser.y"
{
			    PARSE_METRIC_SET(&yyval.metric, yyvsp[0].num);
			    trace(TR_PARSE, 0, "parse: %s METRIC: %d",
				  parse_where(),
				  yyval.metric.metric);
			}
break;
case 485:
#line 3828 "parser.y"
{
			    PARSE_METRIC_INFINITY(&yyval.metric);
			    trace(TR_PARSE, 0, "parse: %s METRIC: infinity",
				  parse_where());
			}
break;
case 486:
#line 3836 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			}
break;
case 487:
#line 3840 "parser.y"
{
			    if (parse_metric_check(parse_export_proto, &yyvsp[0].metric)) {
				PARSE_ERROR;
			    }
			    yyval.metric = yyvsp[0].metric;
			}
break;
case 488:
#line 3850 "parser.y"
{
			    yyval.metric = yyvsp[0].metric;
			}
break;
case 489:
#line 3854 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric);
			}
break;
case 490:
#line 3862 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			}
break;
case 491:
#line 3866 "parser.y"
{
			    PARSE_METRIC_SET(&yyval.metric, yyvsp[0].pref);
			}
break;
case 493:
#line 3874 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric);
			}
break;
case 494:
#line 3880 "parser.y"
{
			    if (parse_limit_check("preference",
						  (u_int) yyvsp[0].num,
						  LIMIT_PREFERENCE)) {
				PARSE_ERROR;
			    }
			    yyval.pref = yyvsp[0].num;
			}
break;
case 495:
#line 3893 "parser.y"
{
			    /* Remove quotes from the string if present */
			    char *cp;

			    yyval.str = yyvsp[0].str;
				
			    switch (*yyval.str.ptr) {
			    case '<':
				*yyval.str.ptr = '>';
				/* Fall through */

			    case '"':
				cp = &yyval.str.ptr[yyval.str.len-1];
				if (*cp == *yyval.str.ptr) {
				    *cp = (char) 0;
				    yyval.str.len -= 2;
				    cp = yyval.str.ptr + 1;
				    break;
				}
				/* Fall Through */

			    default:
				cp = yyval.str.ptr;
			    }

			    yyval.str.ptr = task_mem_strdup((task *) 0, cp);
			    trace(TR_PARSE, 0, "parse: %s STRING: \"%s\" length: %d",
				  parse_where(),
				  yyval.str.ptr,
				  yyval.str.len);
			}
break;
case 497:
#line 3929 "parser.y"
{
			    int i = 0;
			    int len = sizeof(yyval.num);

			    yyval.num = 0;
			    if (yyvsp[0].hex.len > len) {
				sprintf(parse_error, "octet or hex string too long to be a number");
				PARSE_ERROR;
			    } else if (yyvsp[0].hex.len < len) {
				len = yyvsp[0].hex.len;
			    }

			    while (i < len) {
				yyval.num = (yyval.num << 8) | yyvsp[0].hex.ptr[i++];
			    }
			    free_bytestr(&yyvsp[0].hex);
			}
break;
case 500:
#line 3954 "parser.y"
{
			    if (parse_limit_check("seconds",
						  (u_int) yyvsp[0].num,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    };
			    yyval.time = yyvsp[0].num;
			}
break;
case 501:
#line 3963 "parser.y"
{
			    if (parse_limit_check("minutes",
						  (u_int) yyvsp[-2].num,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("seconds",
						  (u_int) yyvsp[0].num,
						  LIMIT_SECONDS)) {
				PARSE_ERROR;
			    }
			    yyval.time = (yyvsp[-2].num * 60) + yyvsp[0].num;
			}
break;
case 502:
#line 3977 "parser.y"
{
			    if (parse_limit_check("hours",
						  (u_int) yyvsp[-4].num,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("minutes",
						  (u_int) yyvsp[-2].num,
						  LIMIT_MINUTES)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("seconds",
						  (u_int) yyvsp[0].num,
						  LIMIT_SECONDS)) {
				PARSE_ERROR;
			    }
			    yyval.time = ((yyvsp[-4].num * 60) + yyvsp[-2].num) * 60 + yyvsp[0].num;
			}
break;
case 503:
#line 3999 "parser.y"
{
			    if (parse_limit_check("port",
						  (u_int) yyvsp[0].num,
						  LIMIT_PORT)) {
				PARSE_ERROR;
			    }
			    yyval.num = htons(yyvsp[0].num);
			}
break;
case 504:
#line 4008 "parser.y"
{
			    const struct servent *sp;

			    if (!(sp = getservbyname(yyvsp[0].str.ptr, parse_serv_proto))) {
				(void) sprintf(parse_error, "unknown protocol %s/%s",
					yyvsp[0].str.ptr, parse_serv_proto);
				PARSE_ERROR;
			    }

			    yyval.num = sp->s_port;

			    trace(TR_PARSE, 0, "parse: %s PORT %s (%d)",
				  parse_where(),
				  yyvsp[0].str.ptr,
				  ntohs(yyval.num));
			}
break;
case 505:
#line 4030 "parser.y"
{
			    if (parse_limit_check("autonomous system",
						  (u_int) yyvsp[0].num,
						  LIMIT_AS)) {
				PARSE_ERROR;
			    }
			    yyval.as = yyvsp[0].num;
			}
break;
case 506:
#line 4041 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_AS | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_as = yyvsp[0].as;
			}
break;
case 507:
#line 4046 "parser.y"
{
			    adv_entry *adv = adv_alloc(ADVFT_AS, (proto_t) 0);

			    adv->adv_as = yyvsp[0].as;
			    yyval.adv = yyvsp[-1].adv;
			    if (parse_adv_append(&yyval.adv, adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 508:
#line 4058 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 509:
#line 4062 "parser.y"
{
			    yyval.adv = yyvsp[0].adv;
			}
break;
case 510:
#line 4073 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			}
break;
case 511:
#line 4077 "parser.y"
{
			    yyval.metric = yyvsp[0].metric;
			}
break;
case 513:
#line 4084 "parser.y"
{
			    PARSE_METRIC_ALTERNATE(&yyval.metric, 0);
			}
break;
case 514:
#line 4088 "parser.y"
{
			    if (parse_limit_check("external-route-tag",
						  (u_int) yyvsp[0].num,
						  PATH_OSPF_TAG_USR_LIMIT)) {
				PARSE_ERROR;
			    }
			    PARSE_METRIC_ALTERNATE(&yyval.metric, yyvsp[0].num);
			}
break;
case 515:
#line 4099 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			}
break;
case 516:
#line 4103 "parser.y"
{
			    yyval.metric = yyvsp[0].metric;
			}
break;
case 517:
#line 4109 "parser.y"
{
			    if (parse_limit_check("external-route-tag",
						  (u_int) yyvsp[0].num,
						  PATH_OSPF_TAG_LIMIT)) {
				PARSE_ERROR;
			    }
			    PARSE_METRIC_SET(&yyval.metric, yyvsp[0].num);
			}
break;
case 526:
#line 4138 "parser.y"
{
			    aspath_state = 0;
			    aspath_current = (asmatch_t *) task_block_alloc(aspath_match_index);
			}
break;
case 527:
#line 4143 "parser.y"
{
			    yyval.asp_match = aspath_current;
			    yyval.asp_match->origin_mask = yyvsp[0].flag;
			    trace(TR_PARSE, 0, "%s: path %X origins %s",
				  parse_where(),
				  yyval.asp_match,
				  aspath_adv_origins(yyval.asp_match->origin_mask));
			    aspath_current = (asmatch_t *) 0;
			}
break;
case 528:
#line 4155 "parser.y"
{
			    /* Set all bits on */
			    yyval.flag = (flag_t) -1;
			}
break;
case 531:
#line 4165 "parser.y"
{
			    yyval.flag = yyvsp[-2].flag | yyvsp[0].flag;
			}
break;
case 532:
#line 4171 "parser.y"
{
			    yyval.flag = (1 << PATH_ORG_IGP);
			}
break;
case 533:
#line 4175 "parser.y"
{
			    yyval.flag = (1 << PATH_ORG_EGP);
			}
break;
case 534:
#line 4179 "parser.y"
{
			    yyval.flag = (1 << PATH_ORG_XX);
			}
break;
case 535:
#line 4185 "parser.y"
{
			    NFA_ASG(yyval.asp_stack.start, yyvsp[0].asp_stack.start);
			    NFA_ASG(aspath_current->start, yyval.asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	regex : sum",
				  parse_where());
			}
break;
case 536:
#line 4192 "parser.y"
{
			    NFA_OR(yyval.asp_stack.start, yyvsp[-2].asp_stack.start, yyvsp[0].asp_stack.start);
			    NFA_OR(yyval.asp_stack.state, yyvsp[-2].asp_stack.state, yyvsp[0].asp_stack.state);
			    NFA_ASG(aspath_current->start, yyval.asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	regex : sum | regex",
				  parse_where());
			}
break;
case 537:
#line 4202 "parser.y"
{
			    trace(TR_PARSE, 0, "%s: REDUCED:	sum : term",
				  parse_where());
			}
break;
case 538:
#line 4207 "parser.y"
{
			    int i;
			    
			    NFA_OR(yyval.asp_stack.state, yyvsp[-1].asp_stack.state, yyvsp[0].asp_stack.state);

			    for (i = 0; i < ASP_ACC; i++) {
				int nonzero;
				
				if (NFA_ISSET(yyvsp[-1].asp_stack.state, i)) {
				    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
					NFA_CLR(aspath_current->nfa[i].next, ASP_ACC);
					NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, yyvsp[0].asp_stack.start);
				    }
				    NFA_CLR(yyvsp[-1].asp_stack.state, i);
				    NFA_NONZERO(yyvsp[-1].asp_stack.state, nonzero);
				    if (nonzero) {
					break;
				    }
				}
			    }
			    if (i > ASP_ACC) {
				YYERROR;
			    }
			    if (NFA_ISSET(yyvsp[-1].asp_stack.start, ASP_ACC)) {
				NFA_CLR(yyvsp[-1].asp_stack.start, ASP_ACC);
				NFA_OR(yyvsp[-1].asp_stack.start, yyvsp[-1].asp_stack.start, yyvsp[0].asp_stack.start);
			    }
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-1].asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	sum : term sum",
				  parse_where());
			}
break;
case 539:
#line 4241 "parser.y"
{
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol",
				  parse_where());
			}
break;
case 540:
#line 4246 "parser.y"
{
			    int i;
			    
			    for (i = 0; i < ASP_ACC; i++) {
				if (NFA_ISSET(yyvsp[-1].asp_stack.state, i)) {
				    int nonzero;
				
				    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
					NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, yyvsp[-1].asp_stack.start);
				    }
				    NFA_CLR(yyvsp[-1].asp_stack.state, i);
				    NFA_NONZERO(yyvsp[-1].asp_stack.state, nonzero);
				    if (nonzero) {
					break;
				    }
				}
			    }
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-1].asp_stack.start);
			    NFA_SET(yyval.asp_stack.start, ASP_ACC);
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol *",
				  parse_where());
			}
break;
case 541:
#line 4269 "parser.y"
{
			    int i;
			    
			    for (i = 0; i < ASP_ACC; i++) {
				if (NFA_ISSET(yyvsp[-1].asp_stack.state, i)) {
				    int nonzero;
				    
				    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
					NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, yyvsp[-1].asp_stack.start);
				    }
				    NFA_CLR(yyvsp[-1].asp_stack.state, i);
				    NFA_NONZERO(yyvsp[-1].asp_stack.state, nonzero);
				    if (nonzero) {
					break;
				    }
				}
			    }
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-1].asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol +",
				  parse_where());
			}
break;
case 542:
#line 4291 "parser.y"
{
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-1].asp_stack.start);
			    NFA_SET(yyval.asp_stack.start, ASP_ACC);
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol ?",
				  parse_where());
			}
break;
case 543:
#line 4298 "parser.y"
{
			    int copy;
			    flag_t finalstate[1 + ASP_ACC / ASP_WORD];
			    flag_t newstate[1 + ASP_ACC / ASP_WORD];
			    flag_t oldstate[1 + ASP_ACC / ASP_WORD];
			    flag_t newstart[1 + ASP_ACC / ASP_WORD];
			    
			    NFA_ASG(finalstate, yyvsp[-3].asp_stack.state);
			    NFA_ASG(newstate, yyvsp[-3].asp_stack.state);
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-3].asp_stack.start);
			    NFA_ASG(newstart, yyvsp[-3].asp_stack.start);
			    if (!yyvsp[-1].asp_range.begin) {
				NFA_SET(yyval.asp_stack.start, ASP_ACC);
			    }
			    for (copy = 1; copy < yyvsp[-1].asp_range.begin; copy++) {
				int i;
				
				NFA_ASG(oldstate, yyvsp[-3].asp_stack.state);
				NFA_ZERO(newstart);
				NFA_ZERO(newstate);
				for (i = 0; i < ASP_ACC; i++) {
				    if (NFA_ISSET(yyvsp[-3].asp_stack.state, i)) {
					aspath_current->nfa[aspath_state].as = aspath_current->nfa[i].as;
					NFA_ASG(aspath_current->nfa[aspath_state].next, aspath_current->nfa[i].next);
					NFA_SHIFT(aspath_current->nfa[aspath_state].next, aspath_state-i);
					NFA_SET(newstate, aspath_state);
					if (NFA_ISSET(yyvsp[-3].asp_stack.start, i)) {
					    int nonzero;
					    
					    NFA_SET(newstart, aspath_state);
					    ASPATH_NEXT_STATE;
					    NFA_CLR(yyvsp[-3].asp_stack.state, i);
					    NFA_NONZERO(yyvsp[-3].asp_stack.state, nonzero);
					    if (nonzero) {
						break;
					    }
					}
				    }
				    if (NFA_ISSET(yyval.asp_stack.start, ASP_ACC)) {
					NFA_OR(yyval.asp_stack.start,yyval.asp_stack.start,newstart);
				    }
				    for (i = 0; i < ASP_ACC; i++) {
					if (NFA_ISSET(oldstate, i)) {
					    int nonzero;
					    
					    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
						if (copy < yyvsp[-1].asp_range.begin) {
						    NFA_CLR(aspath_current->nfa[i].next, ASP_ACC);
						}
						NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, newstart);
					    }
					    NFA_CLR(oldstate, i);
					    NFA_NONZERO(oldstate, nonzero);
					    if (nonzero) {
						break;
					    }
					}
				    }
				    NFA_OR(finalstate, finalstate, newstate);
				    NFA_ASG(yyvsp[-3].asp_stack.start, newstart);
				    NFA_ASG(yyvsp[-3].asp_stack.state, newstate);
				}
				if (yyvsp[-1].asp_range.end) {
				    for (i = 0; i < ASP_ACC; i++) {
					if (NFA_ISSET(newstate, i)) {
					    int nonzero;
					    
					    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
						NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, newstart);
					    }
					    NFA_CLR(newstate, i);
					    NFA_NONZERO(newstate, nonzero);
					    if (nonzero) {
						break;
					    }
					}
				    }
				}	
				NFA_ASG(yyval.asp_stack.state, finalstate);
				trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol { range }",
				      parse_where());
			    }
			}
break;
case 544:
#line 4384 "parser.y"
{
			    NFA_ZERO(yyval.asp_stack.start);
			    NFA_ZERO(yyval.asp_stack.state);
			    NFA_SET(yyval.asp_stack.start, aspath_state);
			    NFA_SET(yyval.asp_stack.state, aspath_state);
			    aspath_current->nfa[aspath_state].as = htons(yyvsp[0].as);
			    NFA_SET(aspath_current->nfa[aspath_state].next, ASP_ACC);
			    ASPATH_NEXT_STATE;
			    trace(TR_PARSE, 0, "%s: REDUCED:	symbol : %d",
				  parse_where(),
				  yyvsp[0].as);
			}
break;
case 545:
#line 4397 "parser.y"
{
			    NFA_ZERO(yyval.asp_stack.start);
			    NFA_ZERO(yyval.asp_stack.state);
			    NFA_SET(yyval.asp_stack.start, aspath_state);
			    NFA_SET(yyval.asp_stack.state, aspath_state);
			    NFA_SET(aspath_current->nfa[aspath_state].next, ASP_ACC);
			    aspath_current->nfa[aspath_state].as = 0;
			    ASPATH_NEXT_STATE;
			    trace(TR_PARSE, 0, "%s: REDUCED:	symbol : .",
				  parse_where());
			}
break;
case 546:
#line 4409 "parser.y"
{
			    NFA_ASG(yyval.asp_stack.state, yyvsp[-1].asp_stack.state);
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-1].asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	symbol : ( regex )",
				  parse_where());
			}
break;
case 547:
#line 4417 "parser.y"
{
			    yyval.asp_range.begin = yyvsp[0].num;
			    yyval.asp_range.end = 0;
			    if (!yyvsp[0].num) {
				sprintf(parse_error, "invalid range start: %d",
					yyvsp[0].num);
				PARSE_ERROR;
			    }
			    trace(TR_PARSE, 0, "%s: RANGE: {%d}",
				  parse_where(),
				  yyval.asp_range.begin);
			}
break;
case 548:
#line 4430 "parser.y"
{
			    yyval.asp_range.begin = yyvsp[-1].num;
			    yyval.asp_range.end = 1;
			    if (!yyvsp[-1].num) {
				sprintf(parse_error, "invalid range start: %d",
					yyvsp[-1].num);
				PARSE_ERROR;
			    }
			    trace(TR_PARSE, 0, "%s: RANGE: {%d,}",
				  parse_where(),
				  yyval.asp_range.begin);
			}
break;
case 549:
#line 4443 "parser.y"
{
			    yyval.asp_range.begin = yyvsp[-2].num;
			    yyval.asp_range.end = yyvsp[0].num;
			    if (!yyvsp[-2].num) {
				sprintf(parse_error, "invalid range start: %d",
					yyvsp[-2].num);
				PARSE_ERROR;
			    }
			    if (yyvsp[0].num < yyvsp[-2].num || !yyvsp[0].num) {
				sprintf(parse_error, "invalid range end: %d",
					yyvsp[0].num);
				PARSE_ERROR;
			    }
			    trace(TR_PARSE, 0, "%s: RANGE: {%d,%d}",
				  parse_where(),
				  yyval.asp_range.begin,
				  yyval.asp_range.end);
			}
break;
#line 6252 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
